//存放用户名或手机号
var username;
var phone;
var password;

//登录成功后的用户信息
var userInfo = {
    username: '',
    userType: '', //1为用户名,2为手机号,3为新浪,4为facebook,5微信，6qq,50为游客登录
    uid: '',
    token: '',
    expire: '',
    changedPassword: '', //点点乐用户登录时：0为未修改密码。  第三方登录时：0为未绑定点点乐账号，1为绑定了点点乐账号
    bindType: '', //0：什么也没绑定，1：绑定了手机，2：绑定了密保，3：都绑定了
    adult: '', //是否成年，0未成年 1成年
}

//用户类型
var USERTYPE_USERNAME = 1;
var USERTYPE_PHONE = 2;
var USERTYPE_SINA = 3;
var USERTYPE_FACEBOOK = 4;
var USERTYPE_WX = 5;
var USERTYPE_QQ = 6;
var USERTYPE_VISITOR = 50;
var USERTYPE_NOIDCARD = 51;

//绑定类型
var BINDTYPE_NULL = 0;
var BINDTYPE_PHONE = 1;
var BINDTYPE_ANSWER = 2;
var BINDTYPE_ALL = 3;

//开关
var phoneRegister_switch ; //1为关闭 0为默认开启,是否屏蔽手机号注册功能
var thirdLogin_switch = '0'; //第三方登录
  /**
     * inland 0 不开放任何三方登录入口
     * 		  1 国内版本 自动开启微信、QQ、（微博暂无）三方登录入口
     * 		  2 国外版本 开启Facebook、Google三方登录入口
     */
var inland = '1';
var isgoogle='0';
//var phoneRegister_switch = '1'; //所有手机相关功能
var vistor_switch = '0'; //游客功能

var isRegiseter = false; //true表示注册成功，自动登录
var isCheckAutoLogin = true; //是否自动登录

var all_userMessage = ''; //存放客户端保存的账号密码组
var default_password = 'ddl_******';

var isSelectUsername = false; //true表示用户选择了下拉列表里面的用户名

var isLoginChangePassword = false; //true表示登录成功时去修改密码，不显示返回按钮

var loginToBind = false; //如果是登录时去绑定则为true，不显示返回按钮

var isCanGetIdentify = true; //是否可以获取验证码

var timerSet0 = false;

var bindIndex = 0; //0绑定手机，1绑定密保

var appidLianWu = '101';
var appidEA = '105';
var version = '';

//图片验证码
var isPhoneImgCode = true;
var imgCodeToken = '';
var deviceId = Math.round(Math.random() * 1000000);
var FacebookPath='';
//设置appid和appsecret
function setAppCallback(appid, appsecret) {
    this.appid = appid;
    this.appsecret = appsecret;

    if (appid == appidLianWu) {
        version = 'v2';
    }
    //    if(appid == appidEA){
    //        $('.login_healthyGame').show();
    //    }
    //    else{
    //        $('.login_healthyGame').hide();
    //    }
}

//设置用户中心信息
function setUserInfo(_userInfo) {
    var u = JSON.parse(_userInfo);
    userInfo.username = base64decode(u.username);
    userInfo.uid = u.uid;
    userInfo.token = u.token;
    userInfo.changedPassword = u.changedPassword;
    userInfo.bindType = parseInt(u.bindType, 10);
    userInfo.userType = parseInt(u.userType);
}

//显示登录界面
function showLoginView(phoneRegister_switch, inland, deviceId, vistor_switch,localeLanguage,facebookPath,isgoogle) {
    this.deviceId = deviceId;
    this.vistor_switch = vistor_switch;
    this.languageIndex = localeLanguage;
    this.FacebookPath=facebookPath;
    this.isgoogle=isgoogle;
     ddlSDK.log('----------------------------'+languageIndex);
    if (phoneRegister_switch == '1') {
        this.phoneRegister_switch = '1';
        isPhoneImgCode = false;
    } else {
        this.phoneRegister_switch = phoneRegister_switch;
    }
    phoneRegisterSwitch = phoneRegister_switch;
    /**
     * inland 0 不开放任何三方登录入口
     * 		  1 国内版本 自动开启微信、QQ、（微博暂无）三方登录入口
     * 		  2 国外版本 开启Facebook、Google三方登录入口
     */
    this.inland = inland;
    if (inland == '0') {
        $('.third_login').hide();
        $('#login_btn_sina_login').hide();
        $('#login_btn_wx_login').hide();
        $('#login_btn_qq_login').hide();
        $('#login_btn_facebook_login').hide();

    } else if (inland == '1') {
        $('#login_btn_sina_login').hide();
        $('#login_btn_facebook_login').hide();

    } else {
        $('#login_btn_sina_login').hide();
        $('#login_btn_wx_login').hide();
        $('#login_btn_qq_login').hide();
    }
    if(isgoogle=='0'){
     $('#login_btn_google_login').hide()
    }

    appRouter.navigate('show/login', { trigger: true });
}

function showLoginViewIos(phoneRegister_switch, inland, deviceId, vistor_switch, iosIsUsingUIWebView,localeLanguage) {
    this.sina_switch = sina_switch;
    this.deviceId = deviceId;
    this.vistor_switch = vistor_switch;
    this.iosIsUsingUIWebView = iosIsUsingUIWebView;
    this.languageIndex = localeLanguage;
    
    phoneRegisterSwitch = phoneRegister_switch;

    if (phoneRegister_switch == '1') {
        this.phoneRegister_switch = '1';
        isPhoneImgCode = false;
    } else {
        this.phoneRegister_switch = phoneRegister_switch;
    }

    this.inland = inland;
    if (inland == '0') {
        $('.third_login').hide();
        $('#login_btn_sina_login').hide();
        $('#login_btn_wx_login').hide();
        $('#login_btn_qq_login').hide();
        $('#login_btn_facebook_login').hide();
        $('#login_btn_google_login').hide();
    } else if (inland == '1') {
        $('#login_btn_sina_login').hide();
        $('#login_btn_facebook_login').hide();
        $('#login_btn_google_login').hide()
    } else {
        $('#login_btn_google_login').hide()
        $('#login_btn_sina_login').hide();
        $('#login_btn_wx_login').hide();
        $('#login_btn_qq_login').hide();
    }
    appRouter.navigate('show/login', { trigger: true });

}


//显示用户中心
function showUserCenter(_userInfo, deviceId,phoneRegister_switch,localeLanguage,facebookPath,isgoogle) {
	this.phoneRegister_switch = phoneRegister_switch;
    this.deviceId = deviceId;
    this.languageIndex = localeLanguage;
    this.FacebookPath=facebookPath;
    this.isgoogle=isgoogle;
    setUserInfo(_userInfo);
    appRouter.navigate('show/userCenter', { trigger: true });
}


function showUserCenterIos(_userInfo, deviceId, iosIsUsingUIWebView,localeLanguage,isgoogle) {
    this.deviceId = deviceId;
    this.iosIsUsingUIWebView = iosIsUsingUIWebView;
    this.languageIndex = localeLanguage;
    this.FacebookPath=facebookPath;
    this.isgoogle=isgoogle;
    setUserInfo(_userInfo);
    appRouter.navigate('show/userCenter', { trigger: true });
}

//显示绑定界面
function showBindAccount(_userInfo, deviceId,phoneRegister_switch,localeLanguage) {
    this.deviceId = deviceId;
    this.phoneRegister_switch = phoneRegister_switch;
    this.languageIndex = localeLanguage;
    setUserInfo(_userInfo);
    if (userInfo.userType == USERTYPE_NOIDCARD) {
        appRouter.navigate('show/registerByUsername', { trigger: true });
    } else {
        if (phoneRegister_switch == '1') {
            appRouter.navigate('show/registerByUsername', { trigger: true });
        } else {
            appRouter.navigate('show/registerByPhone', { trigger: true });
        } 
    }
}

function showBindAccountIos(_userInfo, deviceId, iosIsUsingUIWebView,localeLanguage) {
    this.deviceId = deviceId;
    this.iosIsUsingUIWebView = iosIsUsingUIWebView;
    this.languageIndex = localeLanguage;
    setUserInfo(_userInfo);
    if (userInfo.userType == USERTYPE_NOIDCARD) {
        appRouter.navigate('show/registerByUsername', { trigger: true });
    } else {
        if (phoneRegister_switch == '1') {
            appRouter.navigate('show/registerByUsername', { trigger: true });
        } else {
            appRouter.navigate('show/registerByPhone', { trigger: true });
        }
    }
}

//设置是否自动登陆,本地代码回调方法
function setAutoLoginCheckboxCallback(checkstate) {
    if (checkstate == 'false') {
        isCheckAutoLogin = false;
        $('#login_check_auto_login').attr('checked', false);
    } else {
        isCheckAutoLogin = true;
        $('#login_check_auto_login').attr('checked', true);
    }
}

var lastPwMD5 = ''; //上次登陆账号密码的md5
//设置上次登录的账号密码
function setLastAccessCallback(userName, pwMD5) {
    $("#login_input_username").val(userName);
    $('#login_btn_clearPassword1').val(default_password);
    lastPwMD5 = pwMD5;
}

function setAllUsernameCallBack(_all_userMessage) {
    var lis = document.createDocumentFragment();

    if (_all_userMessage != '') {
        all_userMessage = JSON.parse(_all_userMessage);
        console.log(all_userMessage);

        for (var i = 0; i < all_userMessage.length; i++) {
            all_userMessage[i].username = base64decode(all_userMessage[i].username);

            var li = document.createElement('li');

            li.className = 'liaccountlist';
            
            var i_img = document.createElement('img');
            i_img.className = 'ddl_li_image';


            var i_usertype = all_userMessage[i].userType;
            if(i_usertype == '4'){
            	i_img.setAttribute("class", "ddl_li_facebook_image");
            } else if (i_usertype == '5') {
            	i_img.setAttribute("class", "ddl_li_google_image");
            } else if (i_usertype == '6') {
            	i_img.setAttribute("class", "ddl_li_qq_image");
            } else if (i_usertype == '7') {
            	i_img.setAttribute("class", "ddl_li_google_image");
            } else if (i_usertype == '50') {
            	i_img.setAttribute("class", "ddl_li_vistor_image");
            } else {
            }
            
             var user_name=all_userMessage[i].username;
             if(all_userMessage[i].username.length>18){
               user_name=all_userMessage[i].username.substring(0,18)+'……';
              }
            var btn = document.createElement('button');

            btn.type = 'button';
            btn.className = 'ddl_li_btn btn';
            btn.id = 'login_btn_selectUser' + i;
            btn.appendChild(document.createTextNode(user_name));
            

    		var btndel = document.createElement('img');
    		btndel.className = 'ddl_li_delete_image';
            btndel.id = 'login_btn_selectUser' + i;
            btndel.appendChild(document.createTextNode(user_name));
            

            li.appendChild(i_img);
            
            li.appendChild(btn);

            
            li.appendChild(btndel);
            
            lis.appendChild(li);
        
        }
    } else {
        var li = document.createElement('li');

        li.className = 'linoaccountlist';

        var btn = document.createElement('button');
        btn.type = 'button';
        btn.className = 'ddl_li_btn btn';
        btn.id = 'login_btn_selectUser_null';
        btn.style.color = 'gray';
        btn.appendChild(document.createTextNode(ddlText.no_account[languageIndex]));
        li.appendChild(btn);
        
        lis.appendChild(li);
    }
    $('#login_ul_username').html(lis);
}

function thirdLoginCallback(_userinfo) {
    setUserInfo(_userinfo);

   // $('#ddl_content').empty();
    if (userInfo.userType == USERTYPE_USERNAME || userInfo.userType == USERTYPE_PHONE) {
        $('#ddl_modal_dialog').empty();
        modalContact.set({
            modalTamplate_title: ddlText.prompt[languageIndex],
            modalTamplate_body: ddlText.bind_ddl_account[languageIndex],
            modalTamplate_okid: 'login_modal1_sinaPrompt',
            modalTamplate_ok: ddlText.finish[languageIndex]
        });
        var mt = new modalTamplate1View();

        $('#ddl_modal_dialog').html(mt.render().el);
    } else {
        $('#ddl_modal_title').text(ddlText.prompt[languageIndex]);
        $('#ddl_modal_body').text(ddlText.tobind_ddl_account[languageIndex]);
        $('.ddl_btn_ok').text(ddlText.bind[languageIndex]);
        $('.ddl_btn_cancel').text(ddlText.cancel[languageIndex]);
        $('.ddl_btn_ok').attr('name', '2');
    }
    showDialog();
}

//get获取的
var GETModal = Backbone.Model.extend({

});

var LoginModal = null;
var RegisterModal = null;
var ThirdBindPhoneModel = null;
var ThirdBindUsernameModel = null;
var BindPhoneModal = null;
var UnbindModal = null;
var BindQuestionModal = null;
var ValidateQuestionModal = null;
var UnbindQuestionModal = null;
var validatePasswordModal = null;
var validateCodeModal = null;
var ResetPasswordModal = null;
var ResetPasswordByPasswordModal = null;
var QuestionModal = null;
var ThirdLoginModal = null;
var ValidateImgCodeModal = null;
var VisitorLoginModal = null;
var VisitorBindAccountModel = null;
var VisitorBindPhoneModel = null;

function modalInit(url) {
    if (LoginModal != null) {
        return;
    }
    apiRootUrl = url;
    
    //登录
    LoginModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'Login?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            Sign: '',
            AppId: '',
            UserType: '',
            CheckActive: '',
        }
    });

    //注册
    RegisterModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'registration?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            Sign: '',
            AppId: '',
            UserType: '',
            Code: '',
            TrueName: '',
            IdCard: '',
            version: '',
        }
    });

    //第三方登录
    ThirdLoginModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'thirdlogin?language=' + languageIndex,
        "default": {
            AccessToken: '',
            UId: '',
            AppId: '',
            UserType: '',
        }
    });

    //第三方绑定点点乐手机号
    ThirdBindPhoneModel = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/thirdloginbindphone?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            UId: '',
            Token: '',
            UserType: '',
            SmsCode: '',
            TrueName: '',
            IdCard: '',
            version: '',
        }
    });

    //第三方绑定点点乐用户名
    ThirdBindUsernameModel = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/updatethirdlogin?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            UId: '',
            Token: '',
            UserType: '',
            TrueName: '',
            IdCard: '',
            version: '',
        }
    });

    //绑定手机
    BindPhoneModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/userbindphonenumber?language=' + languageIndex,
        "default": {
            UId: '',
            UpdateToken: '',
            Code: '',
            PhoneNumber: '',
        }
    });

    //解绑手机
    UnbindModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/userbind?language=' + languageIndex,
        "default": {
            UId: '',
            Token: '',
            Code: '',
            BindType: '',
        }
    });

    //绑定密保
    BindQuestionModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'question?language=' + languageIndex,
        "default": {
            UId: '',
            Token: '',
            UpdateToken: '',
            QuestionAnswer: [{
                QuestionId: '',
                Answer: ''
            }, {
                QuestionId: '',
                Answer: ''
            }, {
                QuestionId: '',
                Answer: ''
            }],
        }
    });

    //验证密保答案
    ValidateQuestionModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'verification/question?language=' + languageIndex,
        "default": {
            UserName: '',
            QuestionAnswer: [{
                QuestionId: '',
                Answer: ''
            }, {
                QuestionId: '',
                Answer: ''
            }],
        }
    });

    //解绑密保
    UnbindQuestionModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/unbindquestion?language=' + languageIndex,
        "default": {
            Token: '',
            UId: '',
            QuestionAnswer: [{
                QuestionId: '',
                Answer: ''
            }, {
                QuestionId: '',
                Answer: ''
            }],
        }
    });

    //验证密码
    validatePasswordModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'verification/password?language=' + languageIndex,
        "default": {
            UId: '',
            Token: '',
            Password: '',
        }
    });

    //验证验证码
    validateCodeModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'verification/phonenumbercode?language=' + languageIndex,
        "default": {
            UserName: '',
            Code: '',
        }
    });

    //重置密码
    ResetPasswordModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/password?language=' + languageIndex,
        "default": {
            UserName: '',
            Token: '',
            Password: '',
        }
    });

    //修改密码
    ResetPasswordByPasswordModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/newpassword?language=' + languageIndex,
        "default": {
            UId: '',
            Token: '',
            NewPassword: '',
            OldPassword: '',
        }
    });

    //验证图片验证码
    ValidateImgCodeModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'VerificationImage?language=' + languageIndex,
        "default": {
            Id: '',
            Code: '',
        }
    });

    //获取所有的密保问题
    QuestionModal = Backbone.Model.extend({
        "default": {
            QuestionId: '',
            QuestionName: '',
            QuestionState: ''
        }
    });

    //游客登录
    VisitorLoginModal = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'Guest/GuestLogin?language=' + languageIndex,
        "default": {
            DeviceId: '',
            Sign: '',
            AppId: '',
            UserType: USERTYPE_VISITOR,
        }
    });

    //游客绑定点点乐用户名账号
    VisitorBindAccountModel = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'Guest/bindaccount?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            Sign: '',
            Token: '',
            UserType: '',
            AppId: '',
            DeviceId: '',
            TrueName: '',
            IdCard: '',
            version: '',
        }
    });

    //游客绑定点点乐手机账号
    VisitorBindPhoneModel = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'Guest/bindphone?language=' + languageIndex,
        "default": {
            UserName: '',
            Password: '',
            Sign: '',
            Token: '',
            UserType: '',
            AppId: '',
            DeviceId: '',
            SmsCode: '',
            TrueName: '',
            IdCard: '',
            version: '',
        }
    });

    //老账号绑定身份证姓名
    BindIdcardModel = Backbone.Model.extend({
        urlRoot: apiRootUrl + 'security/bindidentityinfo?language=' + languageIndex,
        "default": {
            AppId: '',
            UId: '',
            TrueName: '',
            IdCard: '',
            Signature: '',
        }
    });
}

//modalInit('http://106.75.15.190/api/');
//modalInit('https://passport.ddianle.com/api/');
//modalInit('http://sandbox.ddianle.com/api/');
//modalInit('http://172.16.6.14/api/');
//modalInit('http://107.155.55.212/api/')

function getImgCode() {
    ddlSDK.showLoading();
    var m = new GETModal();
    m.urlRoot = apiRootUrl + 'VerificationImage/' + deviceId;
    m.fetch({
        success: function(model, response) {
            ddlSDK.hideLoading();
            console.log(response);
            if (response.Code != undefined && response.Code == 10000 && response.Message != undefined) {
                isPhoneImgCode = false;
                return;
            }
            isPhoneImgCode = true;
            $('#ddl_img_imgCode').attr('src', 'data:image/png;base64,' + response.Message);
        },
        error: function(err) {
            isPhoneImgCode = false;
            ddlSDK.hideLoading();
        }
    });
}

// 登录界面
var LoginView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_login').html()),
    events: {
        'click #login_btn_register': 'toRegister',
        'click #login_btn_login': 'login',
        'click #login_btn_sina_login': 'sinaLogin',
        'click #login_btn_facebook_login': 'facebookLogin',
        'click #login_btn_google_login': 'googleLogin',
        'click #login_btn_wx_login': 'WxLogin',
        'click #login_btn_qq_login': 'QQLogin',
        'click #login_a_forgetPassword': 'toForgetpassword',
        'click .ddl_li_btn': 'selectUsername',
        'click .ddl_li_delete_image': 'deleteUsername',
        'focus #login_input_username': 'showPromptMsg',
        'click #login_btn_vistor': 'vistorLogin',
        'click #login_check_auto_login': 'autoLoginChecked',
        'click #login_btn_dropdown': 'dropdownUsername'

    },

    render: function() {
        this.$el.html(this.template);
        titleContact.set({
//            titleTamplateTitle: ddlText.login[languageIndex],
 titleTamplateTitle: '',

              titleTamplateBackHtml: 'id="login_btn_back"'

        });
        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#login_nav_title')).append(titleTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="login_btn_clearPassword1" placeholder="' + ddlText.pwd[languageIndex] + '"',
            inputTamplateBtnId: 'login_btn_clearPassword',
            inputTamplateInputPromptId: ''
        });

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#login_div_password')).append(inputTamplateView.render().el);

        ddlSDK.setApp();
        ddlSDK.setAutoLoginCheckbox();

        modalContact.set({
            modalTamplate_title: ddlText.security_level_low[languageIndex],
            modalTamplate_body: ddlText.nobind_prompt[languageIndex],
            modalTamplate_ok: ddlText.bind[languageIndex],
            modalTamplate_okid: 'login_modal_ok',
            modalTamplate_cancelid: 'registerByPhone_modal_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });

        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);
        $('.ddl_btn_ok').attr('name', '0');
        if (username != null && password != null) {
            $('#login_input_username').val(username);
            $('#login_btn_clearPassword1').val(password);
        }

        $('#login_input_username').attr('placeholder', ddlText.account[languageIndex]);
        $('#login_btn_login').text(ddlText.login[languageIndex]);
        $('#login_btn_register').text(ddlText.register[languageIndex]);
        $('#login_span_auto_login').text(ddlText.auto_login[languageIndex]);
        $('#login_a_forgetPassword').text(ddlText.forget_pwd[languageIndex]);
        $('.third_login span').text(ddlText.support_login[languageIndex] + ':');
        $('#login_div_healthyGame').text(ddlText.advice_age[languageIndex] );
        $('#login_btn_vistor').text(ddlText.visitor_login[languageIndex]);
        if(phoneRegister_switch == '1'){
        	$('#login_div_healthyGame').hide();
        	$('#third_support_login_text').hide();
        }
        
        if (all_userMessage == '') {
            ddlSDK.setAllUsername();
        } else {
            var lis = document.createDocumentFragment();
            for (var i = 0; i < all_userMessage.length; i++) {
                var li = document.createElement('li');

                li.className = 'liaccountlist';
                
                var i_img = document.createElement('img');
                i_img.className = 'ddl_li_image';
                var i_usertype = all_userMessage[i].userType;
                if(i_usertype == '4'){
                	i_img.setAttribute("class", "ddl_li_facebook_image");
                } else if (i_usertype == '5') {
                	i_img.setAttribute("class", "ddl_li_google_image");
                } else if (i_usertype == '6') {
                	i_img.setAttribute("class", "ddl_li_qq_image");
                } else if (i_usertype == '7') {
                	i_img.setAttribute("class", "ddl_li_google_image");
                } else if (i_usertype == '50') {
                	i_img.setAttribute("class", "ddl_li_vistor_image");
                } else {

                }
                var user_name=all_userMessage[i].username;
                if(all_userMessage[i].username.length>18){
                user_name=all_userMessage[i].username.substring(0,18)+'……';
                }

                var btn = document.createElement('button');
                btn.type = 'button';
                btn.className = 'ddl_li_btn btn';
                btn.id = 'login_btn_selectUser' + i;

                btn.appendChild(document.createTextNode(user_name));
                
                var btndel = document.createElement('img');
                btndel.className = 'ddl_li_delete_image';
                btndel.id = 'login_btn_selectUser' + i;
                btndel.appendChild(document.createTextNode(user_name));

                li.appendChild(i_img);
                
                li.appendChild(btn);

                li.appendChild(btndel);
                
                lis.appendChild(li);
            }
            $('#login_ul_username').html(lis);
        }

        if (isRegiseter) {
            isRegiseter = false;
            this.login();
        }
//        if (inland == '0') {
//            $('.third_login').hide();
//            $('#login_btn_sina_login').hide();
//            $('#login_btn_wx_login').hide();
//            $('#login_btn_qq_login').hide();
//            $('#login_btn_facebook_login').hide();
//            $('#login_btn_google_login').hide();
//        } else if (inland == '1') {
//            $('#login_btn_sina_login').hide();
//            $('#login_btn_facebook_login').hide();
//        } else {
//            $('#login_btn_sina_login').hide();
//            $('#login_btn_wx_login').hide();
//            $('#login_btn_qq_login').hide();
//        }
//         if(isgoogle=='0'){
//             $('#login_btn_google_login').hide()
//            }
        //屏蔽游客登录
//        if (vistor_switch == '1') {
//            $('#login_btn_vistor').hide();
////            $('#login_btn_login').removeClass('col-xs-12');
////            $('#login_btn_login').addClass('col-xs-6');
//        }

        $('.ddl_btn_close').hide();

        return this;
    },

    dropdownUsername: function() {
        if ($('#login_ul_username').html().indexOf('li') < 0) {
            ddlSDK.setAllUsername();
        }
    },

    autoLoginChecked: function() {
        if ($('#login_check_auto_login').is(':checked')) {
            isCheckAutoLogin = true;
        } else {
            isCheckAutoLogin = false;
        }
    },

    toRegister: function() {
        if (phoneRegister_switch == '0')
            appRouter.navigate('show/registerByPhone', { trigger: true });
        else
            appRouter.navigate('show/registerByUsername', { trigger: true });
    },

    login: function() {
        var loginJson = {
            uid: '',
            token: '',
            state: ''
        };
        if (input_be_null('#login_input_username')) {
            username = $('#login_input_username').val();
            var password = $('#login_btn_clearPassword1').val();
            var pwMD5 = $.md5(password);
            if (password == default_password && all_userMessage != '') {
                for (var i = 0; i < all_userMessage.length; i++) {
                    if (username == all_userMessage[i].username) {
                        pwMD5 = all_userMessage[i].pwMD5;
                        break;
                    }
                }
            } else if (password == default_password && all_userMessage == '') {
                pwMD5 = lastPwMD5;
            }
            var sign = getMD5(username + pwMD5);
            var checkAct = false;
            if (appid == appidEA) {
                checkAct = true;
            }

            var m = new LoginModal();

            m.set({
                UserName: username,
                Password: pwMD5,
                Sign: sign,
                AppId: appid,
                CheckActive: checkAct
            });
            ddlSDK.showLoading();
            console.log(m.toJSON());
            m.save(null, {
                success: function(model, response) {
                    console.log(response);
                    ddlSDK.hideLoading();

                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                 //   $('#ddl_content').empty();
                    userInfo.username = response.UserName;
                    userInfo.uid = response.UId;
                    userInfo.token = response.Token;
                    userInfo.expire = response.Expire;
                    userInfo.bindType = response.BindType;
                    userInfo.changedPassword = response.ChangedPassword;
                    userInfo.userType = response.UserType;
                    userInfo.adult = response.IsAdult;

                    //用于自动登录
                    ddlSDK.saveValue('username', userInfo.username);
                    ddlSDK.saveValue('pwMD5', pwMD5);
                    ddlSDK.saveValue('sign', sign);
                    ddlSDK.saveValue('ChangedPassword', userInfo.changedPassword);
                    ddlSDK.saveValue('userType', userInfo.userType);
                    
                    //第三方自动登录状态标记为sdk自有登录
                    ddlSDK.removeValue("auto_login_planform");
                    ddlSDK.saveValue("auto_login_planform", "sdklogin");
                    
                    //第三方账号自动登录设置--官方
//                    ddlSDK.savaValue('thirdLoginAutoPlatform','official');
//                    ddlSDK.saveValue('autoLoginChecked', 'checked');

                    if (response.IsLegalID != undefined && (response.IsLegalID == '0' || response.IsLegalID == 0)) {
                        userInfo.userType = USERTYPE_NOIDCARD;
                        response.UserType = USERTYPE_NOIDCARD;
                    }
                    isCheckAutoLogin=true;
                    if (isCheckAutoLogin) {
                        ddlSDK.saveValue('autoLoginChecked', 'checked');
                    } else {
                        ddlSDK.saveValue('autoLoginChecked', 'false');
                    }

                    ddlSDK.loginCallBack(JSON.stringify(response));

                    if (phoneRegister_switch == '1') {
                        $('#ddl_modal_body').text(ddlText.nobind_prompt_bindQuestion[languageIndex]);
                    }
                    //手机号登录，且未修改密码
                    if (userInfo.changedPassword == 0 && allNumber.test(username)) {
                        isLoginChangePassword = true;
                        $('#ddl_modal_body').text(ddlText.pwd_is_code[languageIndex]);
                        $('.ddl_btn_ok').text(ddlText.change[languageIndex]);
                        $('.ddl_btn_cancel').text(ddlText.cancel[languageIndex]);
                        $('.ddl_btn_ok').attr('name', '1');
                        showDialog();
                    } else if (userInfo.bindType == BINDTYPE_NULL || userInfo.changedPassword == 0) { //普通用户登陆，没有绑定过任何信息
                        showDialog();
                    } else {
                        toastr.success(ddlText.login_suc[languageIndex]);
                        ddlSDK.closePage();
                    }

                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                    loginJson.state = '1';
                    ddlSDK.loginCallBack(JSON.stringify(loginJson));
                }
            });
        }
    },

    sinaLogin: function() {

        window.location.href = "https://open.weibo.cn/oauth2/authorize?client_id=819650358&redirect_uri=ddl://sinaLogin.json&response_type=code&display=mobile&forcelogin=true&state=authorize";
        ddlSDK.showCloseButton();
    },

    facebookLogin: function() {
    isCheckAutoLogin=true;
        if (isCheckAutoLogin) {
            ddlSDK.saveValue('autoLoginChecked', 'checked');
        } else {
            ddlSDK.saveValue('autoLoginChecked', 'false');
        }
        ddlSDK.ThirdFacebookLogin();
    },
    googleLogin: function() {
    isCheckAutoLogin=true;
        if (isCheckAutoLogin) {
            ddlSDK.saveValue('autoLoginChecked', 'checked');
        } else {
            ddlSDK.saveValue('autoLoginChecked', 'false');
        }
        ddlSDK.ThirdGoogleLogin();
    },
    WxLogin: function() {
        if (isCheckAutoLogin) { 
            ddlSDK.saveValue('autoLoginChecked', 'checked');
        } else {
            ddlSDK.saveValue('autoLoginChecked', 'false');
        }
        // window.location.href ="https://open.weixin.qq.com/connect/qrconnect?appid=wxae0dd250c12cfa40&redirect_uri="+encodeURIComponent("http://www.uniugame.com")+"&response_type=code&scope=snsapi_login&state=wechatlogin"
        ddlSDK.WxLogin();
    },
    QQLogin: function() {
        if (isCheckAutoLogin) { 
            ddlSDK.saveValue('autoLoginChecked', 'checked');
        } else {
            ddlSDK.saveValue('autoLoginChecked', 'false');
        }
		ddlSDK.QQLogin();
        //window.location.href = "https://graph.qq.com/oauth2.0/authorize?response_type=code&client_id=1106619006&redirect_uri=" + encodeURIComponent("ddl://sinaLogin.json") + "&state=qqlogin&scope=get_user_info"
        //ddlSDK.showCloseButton();
    },

    toForgetpassword: function() {
        appRouter.navigate('show/forgetPassword', { trigger: true });
    },

    selectUsername: function(e) {
        var id = '#' + e.currentTarget.id;
        var s = $(id).text();
        console.log(s);
        if (s != ddlText.no_account[languageIndex]) {

            for (var i = 0; i < all_userMessage.length; i++) {
            if(s.length>18&&all_userMessage[i].username.length>18){
                if(s.substring(0,18)==all_userMessage[i].username.substring(0,18)){
                 $('#login_input_username').val(all_userMessage[i].username);
                 if (all_userMessage[i].pwMD5 == '') {
                      $('#login_btn_clearPassword1').val('');
                  } else {
                   $('#login_btn_clearPassword1').val(default_password);
                  }
                  if(all_userMessage[i].userType == '4'){
		  	ddlSDK.ThirdFacebookLogin();
                    	break;
                   }else if(all_userMessage[i].userType == '5'){
                   ddlSDK.ThirdGoogleLogin();
                      break;
                    }else if( all_userMessage[i].userType == '6'){
                         break;
                     }else if( all_userMessage[i].userType == '7'){
                       break;
                     }else if( all_userMessage[i].userType == '50'){
                      this.vistorLogin();
                       break;
                     }
                 }
             }else if(s == all_userMessage[i].username) {
                 $('#login_input_username').val(s);
                    if (all_userMessage[i].pwMD5 == '') {
                        $('#login_btn_clearPassword1').val('');
                    } else {
                        $('#login_btn_clearPassword1').val(default_password);
                    }
                   if(all_userMessage[i].userType == '4'){
		   	ddlSDK.ThirdFacebookLogin();
                               		break;
                               	}else if( all_userMessage[i].userType == '5'){
                               	ddlSDK.ThirdGoogleLogin();
                               		break;
                               	}else if(all_userMessage[i].userType == '6'){
                               		break;
                               	}else if( all_userMessage[i].userType == '7'){
                               		break;
                               	}else if( all_userMessage[i].userType == '50'){
                               		this.vistorLogin();
                               		break;
                               	}
                }
            }
            isSelectUsername = true;
        }
    },
    
    deleteUsername: function(e){
    	var id = '#'+ e.currentTarget.id;
    	var s = $(id).text();
    	console.log(s);
        if (s != ddlText.no_account[languageIndex]) {

        	var len = all_userMessage.length;

        	var input_username = $('#login_input_username').val();
            for (var i = 0; i < all_userMessage.length; i++) {
            if(s.length>18&&all_userMessage[i].username.length>18){
                if(s.substring(0,18)==all_userMessage[i].username.substring(0,18)){
                   if(all_userMessage[i].username==input_username){
                   $('#login_input_username').val('');
                   $('#login_btn_clearPassword1').val('');
                   }
                   s=all_userMessage[i].username;
                 delete all_userMessage[i][s];
                 ddlSDK.deleteUserForUsername(all_userMessage[i].username);
                }
            }else if (s == all_userMessage[i].username) {
                	if(s == input_username){
                		$('#login_input_username').val('');
                		$('#login_btn_clearPassword1').val('');
                	}
                	delete all_userMessage[i][s];
                	
                    ddlSDK.deleteUserForUsername(all_userMessage[i].username);

                    break;
                }
            }
        }
    },

    vistorLogin: function() {
        var loginJson = {
            uid: '',
            token: '',
            state: ''
        };
        var m = new VisitorLoginModal();
        var signstr = $.md5(appid + appsecret + deviceId + USERTYPE_VISITOR);
        m.set({
            DeviceId: deviceId,
            Sign: signstr,
            AppId: appid,
            UserType: USERTYPE_VISITOR,
        });
        ddlSDK.log("appid-->" + appid + ";appsecret-->" + appsecret + ";deviceId-->" + deviceId + ";USERTYPE_VISITOR-->" + USERTYPE_VISITOR + ";signstr-->" + signstr);
        ddlSDK.showLoading();
        console.log(m.toJSON());
        m.save(null, {
            success: function(model, response) {
                console.log(response);
                ddlSDK.hideLoading();

                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
              //  $('#ddl_content').empty();
                userInfo.username = response.UserName;
                userInfo.uid = response.UId;
                userInfo.token = response.Token;
                userInfo.expire = response.Expire;
                userInfo.bindType = response.BindType;
                userInfo.changedPassword = response.ChangedPassword;
                userInfo.userType = response.UserType;
                userInfo.adult = '0';

                ddlSDK.saveValue('username', deviceId);
                ddlSDK.removeValue('pwMD5');
                ddlSDK.saveValue('sign', signstr);
                ddlSDK.saveValue('userType', USERTYPE_VISITOR);
                ddlSDK.saveValue('ChangedPassword', userInfo.changedPassword);

                //用于自动登录

                //第三方自动登录状态标记为sdk自有登录
                ddlSDK.removeValue("auto_login_planform");
                ddlSDK.saveValue("auto_login_planform", "sdklogin");
                
//              第三方账号自动登录设置--官方
//                ddlSDK.savaValue('','');
//                ddlSDK.saveValue('thirdLoginAutoPlatform', 'official');
                isCheckAutoLogin=true;
                if (isCheckAutoLogin) {
                    ddlSDK.saveValue('autoLoginChecked', 'checked');
                } else {
                    ddlSDK.saveValue('autoLoginChecked', 'false');
                }	
                
                ddlSDK.loginCallBack(JSON.stringify(response));

                //toastr.success(ddlText.login_suc[languageIndex]);
                //ddlSDK.closePage();
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
                loginJson.state = '1';
                ddlSDK.loginCallBack(JSON.stringify(loginJson));
            }
        });
    }

});

// 手机注册界面
var RegisterByPhoneView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_registerByPhone').html()),

    events: {
        'click #registerByPhone_btn_next': 'toRegisterByPhoneNext',
        'click #registerByPhone_btn_registerByUsername': 'toRegisterByUsername',
    },

    render: function() {
        this.$el.html(this.template);

        if (userInfo.userType == '') {
            titleContact.set({
                titleTamplateTitle: ddlText.register_phone[languageIndex],
                titleTamplateBackHtml: 'id="registerByPhone_btn_back"'
            });
            $('#registerByPhone_btn_registerByUsername').text(ddlText.register_username[languageIndex]);
        } else {
            titleContact.set({
                titleTamplateTitle: ddlText.bind_account[languageIndex],
                titleTamplateBackHtml: 'hidden '
            });
            ddlSDK.setApp();
            $('#registerByPhone_btn_registerByUsername').text(ddlText.bindByUsername[languageIndex]);
        }

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-phone',
            inputTamplateInputHtml: 'type="number" id="registerByPhone_btn_clearPhone1" placeholder="' + ddlText.phone[languageIndex] + '"',
            inputTamplateBtnId: 'registerByPhone_btn_clearPhone',
            inputTamplateInputPromptId: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#registerByPhone_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#registerByPhone_div_phone')).append(inputTamplateView.render().el);

        $('#registerByPhone_btn_next').text(ddlText.next[languageIndex]);
        $('#registerByPhone_input_imgCode').text(ddlText.code[languageIndex]);
        // if (userInfo.userType == '') {
        //     $('.ddl_btn_close').hide();
        // }

        return this;
    },

    toRegisterByPhoneNext: function() {
        if (validatePhone('#registerByPhone_btn_clearPhone1')) {
            phone = $('#registerByPhone_btn_clearPhone1').val();
            ddlSDK.showLoading();
            this.validatePhoneIsUsed();
        }
    },

    toRegisterByUsername: function() {
        appRouter.navigate('show/registerByUsername', { trigger: true });
    },

    validatePhoneIsUsed: function() {
        var m = new GETModal();
        m.urlRoot = apiRootUrl + 'registration/duplicate?username=' + encodeURIComponent(phone) + "&language=" + languageIndex;
        m.fetch({
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                appRouter.navigate('show/registerByPhoneNext', { trigger: true });
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

});

// 手机号注册，下一步界面
var RegisterByPhoneNextView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_registerByPhoneNext').html()),

    events: {
        'click #registerByPhoneNext_btn_register': 'registerByPhone',
        'click #registerByPhoneNext_btn_getIdentifyCode': 'getIdentifyCode',
        'input #registerByPhoneNext_input_identifyCode': 'limit'
    },

    render: function() {
        this.$el.html(this.template);

        if (userInfo.userType == '') {
            titleContact.set({
                titleTamplateTitle: ddlText.register_phone[languageIndex],
                titleTamplateBackHtml: ''
            });
            $('#registerByPhoneNext_btn_register').text(ddlText.register[languageIndex]);
        } else {
            titleContact.set({
                titleTamplateTitle: ddlText.bind_account[languageIndex],
                titleTamplateBackHtml: ''
            });
            $('#registerByPhoneNext_btn_register').text(ddlText.bind[languageIndex]);
        }

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#registerByPhoneNext_nav_title')).append(titleTamplateView.render().el);

        $('#registerByPhoneNext_input_identifyCode').attr('placeholder', ddlText.code[languageIndex]);
        $('#registerByPhoneNext_btn_getIdentifyCode').text(ddlText.get_code[languageIndex]);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="text" id="registerByPhoneNext_btn_clearRealname1" placeholder="' + ddlText.realname[languageIndex] +"("+ddlText.realname_limit[languageIndex]+")"+ '"',
            inputTamplateBtnId: 'registerByPhoneNext_btn_clearRealname',
//            inputTamplateInputPromptId: 'registerByPhoneNext_btn_clearRealname1_prompt'
        });

        if (phoneRegister_switch == "0") {
            var inputTamplateView4 = new InputTamplateView();
            this.$el.find($('#registerByPhoneNext_div_realname')).append(inputTamplateView4.render().el);

            inputContact.set({
                inputTamplateSpanClass: 'glyphicon-asterisk',
                inputTamplateInputHtml: 'type="text" id="registerByPhoneNext_btn_clearIdcard1" placeholder="' + ddlText.idcard[languageIndex]+"("+ddlText.idcard_limit[languageIndex]+")" + '"',
                inputTamplateBtnId: 'registerByPhoneNext_btn_clearIdcard',
//                inputTamplateInputPromptId: 'registerByPhoneNext_btn_clearIdcard1_prompt'
            });

            var inputTamplateView5 = new InputTamplateView();
            this.$el.find($('#registerByPhoneNext_div_idcard')).append(inputTamplateView5.render().el);

//            $('#registerByPhoneNext_btn_clearRealname1_prompt').text(ddlText.realname_limit[languageIndex]);
//            $('#registerByPhoneNext_btn_clearIdcard1_prompt').text(ddlText.idcard_limit[languageIndex]);

        }

        var imgInput = '<div class="panel panel-default"><div class="panel-body"><div class="input-group"><span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span><input class="form-control" id="ddl_input_imgCode" placeholder="验证码"><span class="input-group-btn ddl_input_span"><img id="ddl_img_imgCode"></span></div></div></div>';

        modalContact.set({
            modalTamplate_title: '请输入图片验证码',
            modalTamplate_body: imgInput,
            modalTamplate_ok: ddlText.confirm[languageIndex],
            modalTamplate_okid: 'ddl_imgCode_ok',
            modalTamplate_cancelid: 'ddl_imgCode_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });

        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);
        $('.ddl_btn_ok').attr('name', '3');
        $('#ddl_img_imgCode').bind('click', function() { getImgCode(); });
        getImgCode();

        // if (userInfo.userType == '') {
        //     $('.ddl_btn_close').hide();
        // }

        return this;
    },

    registerByPhone: function() {
        var _code = '#registerByPhoneNext_input_identifyCode';
        var input_realname = '#registerByPhoneNext_btn_clearRealname1';
        var input_idcard = '#registerByPhoneNext_btn_clearIdcard1';

        if (validateIdentifyCode(_code) && validateChineseStr(input_realname, 32) && validateIdcard(input_idcard)) {
            var identifyCode = $(_code).val();
            password = identifyCode;
            var pwMD5 = $.md5(identifyCode);
            var sign = getMD5(phone + pwMD5);
            var realname = $(input_realname).val();
            var idcard = $(input_idcard).val();

            if (userInfo.userType == '') {
                var m = new RegisterModal();
                m.set({
                    UserName: phone,
                    Password: pwMD5,
                    Sign: sign,
                    AppId: appid,
                    UserType: USERTYPE_PHONE,
                    Code: identifyCode,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        username = phone;
                        toastr.success(ddlText.register_suc[languageIndex]);
                        isRegiseter = true;
                        ddlSDK.registerSuc(response.UId);
                        appRouter.navigate('show/login', { trigger: true });
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            } else if (userInfo.userType != USERTYPE_VISITOR) {
                var m = new ThirdBindPhoneModel();
                m.set({
                    UserName: phone,
                    Password: pwMD5,
                    UId: userInfo.uid,
                    Token: userInfo.token,
                    UserType: userInfo.userType,
                    SmsCode: identifyCode,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        toastr.success(ddlText.bind_suc[languageIndex]);
                        //绑定成功后修改客户端里面存的username，usertype的值
                        userInfo.username = phone;
                        userInfo.userType = USERTYPE_PHONE;
                        userInfo.bindType = BINDTYPE_PHONE;
                        userInfo.adult = response.IsAdult;

                        ddlSDK.saveValue('username', phone);
                        ddlSDK.saveValue('pwMD5', pwMD5);

                        ddlSDK.saveAccountHistory();
                        ddlSDK.updateUserInfo();

                        ddlSDK.removeValue('autoLoginChecked');

                        appRouter.navigate('show/userCenter', { trigger: true });
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            } else {
                var signstr = $.md5(appid + appsecret + phone + pwMD5 + deviceId);
                var m = new VisitorBindPhoneModel();
                m.set({
                    UserName: phone,
                    Password: pwMD5,
                    Token: userInfo.token,
                    UserType: userInfo.userType,
                    Sign: signstr,
                    AppId: appid,
                    DeviceId: deviceId,
                    SmsCode: identifyCode,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        //绑定成功后修改客户端里面存的username，usertype的值
                        userInfo.username = phone;
                        userInfo.userType = USERTYPE_PHONE;
                        userInfo.bindType = BINDTYPE_PHONE;
                        userInfo.adult = response.IsAdult;

                        ddlSDK.saveValue('username', phone);
                        ddlSDK.saveValue('pwMD5', pwMD5);
                        ddlSDK.saveValue('sign',sign);
                        ddlSDK.saveValue('ChangedPassword','1');
                        ddlSDK.saveValue('userType',USERTYPE_PHONE);
                        ddlSDK.saveValue('bindType',BINDTYPE_PHONE);
                        ddlSDK.saveValue('adult',response.IsAdult);
                        
                      //第三方账号自动登录设置--官方sdk
//                        ddlSDK.savaValue('thirdLoginAutoPlatform','official');

                        ddlSDK.removeValue("auto_login_planform");
                        ddlSDK.saveValue("auto_login_planform", "sdklogin");

                        ddlSDK.updateUserInfo();
                        ddlSDK.bindSuccessCallback(phone, USERTYPE_PHONE);

                        ddlSDK.removeValue('autoLoginChecked');

                        var contactMsg = ddlText.account[languageIndex] + ':' + phone + '<br/><br/>' + ddlText.bindAccount_suc[languageIndex];
                        modalContact.set({
                            modalTamplate_title: ddlText.bind_suc[languageIndex],
                            modalTamplate_body: contactMsg,
                            modalTamplate_okid: 'bindByPhone_modal1_bindOk',
                            modalTamplate_ok: ddlText.finish[languageIndex]
                        });
                        var mt = new modalTamplate1View();

                        $('#ddl_modal_dialog').html(mt.render().el);
                        showDialog();
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            }
        }
    },

    getIdentifyCode: function() {
        if (isCanGetIdentify) {
            if (isPhoneImgCode) {
                getImgCode();
                showDialog();
            } else {
                ddlSDK.getDesString(phone, 'registerGetPhoneDesCallBack');
            }
        }
    },

    limit: function(e) {
        $('#' + e.currentTarget.id).val($('#' + e.currentTarget.id).val());
        limitInputLength($('#' + e.currentTarget.id), 6);
    },

});

function registerGetPhoneDesCallBack(phoneDes) {
    isCanGetIdentify = false;
    ddlSDK.showLoading();
    phoneDes = phoneDes.replace(/\+/g, "-");
    phoneDes = phoneDes.replace(/\//g, "_");
    phoneDes = phoneDes.replace(/\=/g, "~");

    var m = new GETModal();
    if (isPhoneImgCode) {
        m.urlRoot = apiRootUrl + 'sms/' + phoneDes + '?usertype=' + USERTYPE_PHONE + '&sessionid=' + deviceId + '&tokenid=' + imgCodeToken + "&language=" + languageIndex;
    } else {
        m.urlRoot = apiRootUrl + 'sms/' + phoneDes + '?usertype=' + USERTYPE_PHONE + "&language=" + languageIndex;
    }
    console.log(m.urlRoot);
    m.fetch({
        success: function(model, response) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            console.log(response);
            if (isReplyError(response.Message, response.Code)) {
                return;
            }
            toastr.success(ddlText.sended_code[languageIndex]);
            getIdentifyCode('#registerByPhoneNext_btn_getIdentifyCode');
        },
        error: function(err) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            requestFailed();
        }
    });
}

// 用户名注册
var RegisterByUsernameView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_registerByUsername').html()),

    events: {
        'click #registerByUsername_btn_registerByUsername': 'registerByUsername',
        'click #registerByUsername_btn_registerByPhone': 'toRegisterByPhone',
    },

    render: function() {
        this.$el.html(this.template);
        if (userInfo.userType == '') {
            titleContact.set({
                titleTamplateTitle: ddlText.register_username[languageIndex],
                titleTamplateBackHtml: 'id="registerByUsername_btn_back"'
            });
            $('#registerByUsername_btn_registerByUsername').text(ddlText.register[languageIndex]);
            $('#registerByUsername_btn_registerByPhone').text(ddlText.register_phone[languageIndex]);
        } else {
            if (userInfo.userType == USERTYPE_NOIDCARD) {
                titleContact.set({
                    titleTamplateTitle: ddlText.bind_idcard[languageIndex],
                    titleTamplateBackHtml: 'hidden '
                });
                $('#registerByUsername_div_username').hide();
                $('#registerByUsername_div_password').hide();
                $('#registerByUsername_div_confirmPassword').hide();
                $('#registerByUsername_btn_registerByPhone').hide();
            } else {
                titleContact.set({
                    titleTamplateTitle: ddlText.bind_account[languageIndex],
                    titleTamplateBackHtml: 'hidden '
                });
                ddlSDK.setApp();
                $('#registerByUsername_btn_registerByPhone').text(ddlText.bindByPhone[languageIndex]);
            }
            $('#registerByUsername_btn_registerByUsername').text(ddlText.bind[languageIndex]);
        }
        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#registerByUsername_nav_title')).append(titleTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-user',
//            inputTamplateInputHtml: 'type="text" id="registerByUsername_btn_clearUsername1" placeholder="' + ddlText.username[languageIndex] +"("+ddlText.username_limit[languageIndex]+")"+ '"',
             inputTamplateInputHtml: 'type="text" id="registerByUsername_btn_clearUsername1" placeholder="' +ddlText.username_limit[languageIndex]+ '"',
            inputTamplateBtnId: 'registerByUsername_btn_clearUsername',
//            inputTamplateInputPromptId: 'registerByUsername_btn_clearUsername1_prompt'
        });

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#registerByUsername_div_username')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="registerByUsername_btn_clearPassword1" placeholder="' + ddlText.pwd[languageIndex] +"("+ddlText.pwd_limit[languageIndex]+")"+ '" title="new"',
            inputTamplateBtnId: 'registerByUsername_btn_clearPassword',
//            inputTamplateInputPromptId: 'registerByUsername_btn_clearPassword1_prompt'
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#registerByUsername_div_password')).append(inputTamplateView2.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
 //           inputTamplateInputHtml: 'type="password" id="registerByUsername_btn_clearConfirmPassword1" placeholder="' + ddlText.confirm_pwd[languageIndex] +"("+ddlText.pwd_equal[languageIndex]+")"+ '" title="new"',
           inputTamplateInputHtml: 'type="password" id="registerByUsername_btn_clearConfirmPassword1" placeholder="' +ddlText.pwd_equal[languageIndex]+ '" title="new"',
            inputTamplateBtnId: 'registerByUsername_btn_clearConfirmPassword',
//            inputTamplateInputPromptId: 'registerByUsername_btn_clearConfirmPassword1_prompt'
        });

        var inputTamplateView3 = new InputTamplateView();
        this.$el.find($('#registerByUsername_div_confirmPassword')).append(inputTamplateView3.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="text" id="registerByUsername_btn_clearRealname1" placeholder="' + ddlText.realname[languageIndex]+"("+ddlText.realname_limit[languageIndex]+")" + '"',
            inputTamplateBtnId: 'registerByUsername_btn_clearRealname',
//            inputTamplateInputPromptId: 'registerByUsername_btn_clearRealname1_prompt'
        });
//        if (phoneRegister_switch == 0) {
//            var inputTamplateView4 = new InputTamplateView();
//            this.$el.find($('#registerByUsername_div_realname')).append(inputTamplateView4.render().el);
//
//            inputContact.set({
//                inputTamplateSpanClass: 'glyphicon-asterisk',
//                inputTamplateInputHtml: 'type="text" id="registerByUsername_btn_clearIdcard1" placeholder="' + ddlText.idcard[languageIndex] + '"',
//                inputTamplateBtnId: 'registerByUsername_btn_clearIdcard',
//                inputTamplateInputPromptId: 'registerByUsername_btn_clearIdcard1_prompt'
//            });
//
//            var inputTamplateView5 = new InputTamplateView();
//            this.$el.find($('#registerByUsername_div_idcard')).append(inputTamplateView5.render().el);
//
//        }

//        $('#registerByUsername_btn_clearUsername1_prompt').text(ddlText.username_limit[languageIndex]);
//        $('#registerByUsername_btn_clearPassword1_prompt').text(ddlText.pwd_limit[languageIndex]);
//        $('#registerByUsername_btn_clearConfirmPassword1_prompt').text(ddlText.pwd_equal[languageIndex]);
//        $('#registerByUsername_btn_clearRealname1_prompt').text(ddlText.realname_limit[languageIndex]);
//        $('#registerByUsername_btn_clearIdcard1_prompt').text(ddlText.idcard_limit[languageIndex]);
      
        if (phoneRegister_switch == '1') {
            //不显示跳转到手机号注册的按钮
            $('#registerByUsername_btn_registerByPhone').hide();
        }
         if (userInfo.userType == '') {
             $('.ddl_btn_close').hide();
         }


        return this;
    },

    registerByUsername: function() {
        var input_username = '#registerByUsername_btn_clearUsername1';
        var input_password = '#registerByUsername_btn_clearPassword1';
        var input_confirmPassword = '#registerByUsername_btn_clearConfirmPassword1';
        var input_realname = '#registerByUsername_btn_clearRealname1';
        var input_idcard = '#registerByUsername_btn_clearIdcard1';

        if ((userInfo.userType == USERTYPE_NOIDCARD || (userInfo.userType != USERTYPE_NOIDCARD && validateUsername(input_username) && validatePassword(input_password) && validateConfirmPassword(input_password, input_confirmPassword))
        				) && 
        		((validateChineseStr(input_realname, 32) && validateIdcard(input_idcard))||(phoneRegister_switch != 0))) {
            //            console.log("ok");
            //            return;
            username = $(input_username).val();
            password = $(input_password).val();
            var confirmPassword = $(input_confirmPassword).val();
            var pwMD5 = $.md5(password);
            var sign = getMD5(username + pwMD5);
            var realname = $(input_realname).val();
            var idcard = $(input_idcard).val();

            if (userInfo.userType == '') {
                var m = new RegisterModal();
                m.set({
                    UserName: username,
                    Password: pwMD5,
                    Sign: sign,
                    AppId: appid,
                    UserType: USERTYPE_USERNAME,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            username = '';
                            password = '';
                            return;
                        }
                        toastr.success(ddlText.register_suc[languageIndex]);
                        isRegiseter = true;
                        ddlSDK.registerSuc(response.UId);
                        appRouter.navigate('show/login', { trigger: true });
                    },
                    error: function(err) {
                        username = '';
                        password = '';
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            } else if (userInfo.userType >= USERTYPE_SINA && userInfo.userType < USERTYPE_VISITOR) {
                var m = new ThirdBindUsernameModel();
                m.set({
                    UserName: username,
                    Password: pwMD5,
                    UId: userInfo.uid,
                    Token: userInfo.token,
                    UserType: userInfo.userType,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        toastr.success(ddlText.bind_suc[languageIndex]);
                        //绑定成功后修改客户端里面存的username，usertype的值
                        userInfo.username = username;
                        userInfo.userType = USERTYPE_USERNAME;
                        userInfo.adult = response.IsAdult;

                        ddlSDK.saveValue('username', username); 
                        ddlSDK.saveValue('pwMD5', pwMD5);
                        ddlSDK.saveValue('sign', sign);
                        ddlSDK.saveValue('ChangedPassword', '1');
                        ddlSDK.saveValue('userType', USERTYPE_USERNAME);

                        ddlSDK.updateUserInfo();
                        ddlSDK.bindSuccessCallback(username, USERTYPE_USERNAME);
                        isCheckAutoLogin=true;
                        if (isCheckAutoLogin) {
                            ddlSDK.saveValue('autoLoginChecked', 'checked');
                        } else {
                            ddlSDK.saveValue('autoLoginChecked', 'false');
                        }

                        ddlSDK.saveAccountHistory();
                        appRouter.navigate('show/userCenter', { trigger: true });
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
             } else if (userInfo.userType == USERTYPE_VISITOR) {
                var signstr = $.md5(appid + appsecret + username + pwMD5 + deviceId);
                var m = new VisitorBindAccountModel();
                m.set({
                    UserName: username,
                    Password: pwMD5,
                    Token: userInfo.token,
                    UserType: userInfo.userType,
                    Sign: signstr,
                    AppId: appid,
                    DeviceId: deviceId,
                    TrueName: realname,
                    IdCard: idcard,
                    version: version,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        //绑定成功后修改客户端里面存的username，usertype的值
                        userInfo.username = username;
                        userInfo.userType = USERTYPE_USERNAME;
                        userInfo.adult = response.IsAdult;

                        ddlSDK.saveValue('username', username);
                        ddlSDK.saveValue('pwMD5', pwMD5);
                        ddlSDK.saveValue('sign', sign);
                        ddlSDK.saveValue('ChangedPassword', '1');
                        ddlSDK.saveValue('userType', USERTYPE_USERNAME);
                        isCheckAutoLogin=true;
                        if (isCheckAutoLogin) {
                            ddlSDK.saveValue('autoLoginChecked', 'checked');
                        } else {
                            ddlSDK.saveValue('autoLoginChecked', 'false');
                        }

                        ddlSDK.updateUserInfo();
                        ddlSDK.bindSuccessCallback(username, USERTYPE_USERNAME);

                        var contactMsg = ddlText.account[languageIndex] + ':' + username + '<br/><br/>' + ddlText.bindAccount_suc[languageIndex];
                        modalContact.set({
                            modalTamplate_title: ddlText.bind_suc[languageIndex],
                            modalTamplate_body: contactMsg,
                            modalTamplate_okid: 'bindByUsername_modal1_bindOk',
                            modalTamplate_ok: ddlText.finish[languageIndex]
                        });
                        var mt = new modalTamplate1View();

                        $('#ddl_modal_dialog').html(mt.render().el);
                        showDialog();
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            } else if (userInfo.userType == USERTYPE_NOIDCARD) {
                var signstr = $.md5(appid + appsecret + userInfo.uid + realname + idcard);
                var m = new BindIdcardModel();
                m.set({
                    AppId: appid,
                    UId: userInfo.uid,
                    TrueName: realname,
                    IdCard: idcard,
                    Signature: signstr,
                });
                console.log(JSON.stringify(m));
                ddlSDK.showLoading();

                m.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        //绑定成功后修改客户端里面存的username，usertype的值
                        userInfo.userType = response.UserType;
                        userInfo.adult = response.IsAdult;
                        ddlSDK.updateUserInfo();

                        var contactMsg = ddlText.bindIdcard_suc[languageIndex];
                        modalContact.set({
                            modalTamplate_title: ddlText.bind_suc[languageIndex],
                            modalTamplate_body: contactMsg,
                            modalTamplate_okid: 'bindByUsername_modal1_bindOk',
                            modalTamplate_ok: ddlText.finish[languageIndex]
                        });
                        var mt = new modalTamplate1View();

                        $('#ddl_modal_dialog').html(mt.render().el);
                        showDialog();
                    },
                    error: function(err) {
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            }
        }
    },

    toRegisterByPhone: function() {
        appRouter.navigate('show/registerByPhone', { trigger: true });
    }
});

//用户绑定的三个问题和id
var q0, q1, q2;
var qid0, qid1, qid2;

//忘记码界面
var ForgetPasswordView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_forgetPassword').html()),

    events: {
        'click #forgetPassword_btn_to_resetPasswordByPhone': 'toResetPasswordByPhone',
        'click #forgetPassword_btn_to_resetPasswordByQuestion': 'toResetPasswordByQuestion',
    },

    render: function() {
        this.$el.html(this.template);

        titleContact.set({
            titleTamplateTitle: ddlText.forget_pwd[languageIndex],
            titleTamplateBackHtml: ''
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-user',
            inputTamplateInputHtml: 'type="text" id="forgetPassword_div_clearUser1" placeholder="' + ddlText.account[languageIndex] + '"',
            inputTamplateBtnId: 'forgetPassword_div_clearUser',
            inputTamplateInputPromptId: ''
        });

        $('#ddl_modal_dialog').empty();

        //联系方式
        var contactMsg = '';
        contactMsg = '<center>' + ddlText.contact_way[languageIndex] + '</center></br><center><span >'+ddlText.fbpage[languageIndex]+'：</span>'+FacebookPath+'</center></br><span class="ddl_css_modal_content_left">' + ddlText.email[languageIndex] + '：</span>uniugame@uniugame.com</br>' ;

        modalContact.set({
            modalTamplate_body: contactMsg,
            modalTamplate_okid: 'forgetPassword_modal1_prompt',
            modalTamplate_ok: ddlText.finish[languageIndex]
        });
        var mt = new modalTamplate1View();

        $('#ddl_modal_dialog').html(mt.render().el);
        $('#ddl_modal_body').removeClass('ddl_css_modal_body');

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#forgetPassword_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#forgetPassword_div_user')).append(inputTamplateView.render().el);

        $('#forgetPassword_btn_to_resetPasswordByPhone').text(ddlText.reset_phone[languageIndex]);
        $('#forgetPassword_btn_to_resetPasswordByQuestion').text(ddlText.reset_question[languageIndex]);
        $('#forgetPassword_input_imgCode').text(ddlText.code[languageIndex]);

        $('#forgetPassword_panel_imgCode').hide();
        if (phoneRegister_switch == '1') {
            $('#forgetPassword_btn_to_resetPasswordByPhone').hide();
            $('#forgetPassword_btn_to_resetPasswordByQuestion').removeClass('col-xs-padding-6');
            $('#forgetPassword_btn_to_resetPasswordByQuestion').addClass('col-xs-12');
        }

        $('.ddl_btn_close').hide();
        return this;
    },

    toResetPasswordByPhone: function() {
        ddlSDK.openlog();
        this.validateImgCode(0);
    },

    toResetPasswordByQuestion: function() {
        ddlSDK.openlog();
        this.validateImgCode(1);
    },

    //type = 0 为通过手机验证，= 1 为密保
    validateImgCode: function(type) {
        username = $('#forgetPassword_div_clearUser1').val();

        if (input_be_null('#forgetPassword_div_clearUser1')) {
            ddlSDK.showLoading();
            this.validateAccount(type);
        }
    },

    validateAccount: function(type) {
        var view = this;
        var m = new GETModal();
        m.urlRoot = apiRootUrl + 'security/checkusername?username=' + encodeURIComponent(username) + "&language=" + languageIndex;
        m.fetch({
            success: function(model, response) {
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    ddlSDK.hideLoading();
                    return;
                }
                if (type == 0) {
                    view.getBindType();
                } else if (type == 1) {
                    view.getBindQuestion();
                }
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

    getBindType: function() {
        var m2 = new GETModal();
        m2.urlRoot = apiRootUrl + 'security/userbindtype?username=' + encodeURIComponent(username) + "&language=" + languageIndex;
        m2.fetch({
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                if (response.BindType == 0 || response.BindType == 2) {
                    $('#ddl_modal_title').text(ddlText.nobind_phone[languageIndex]);
                    showDialog();
                    return;
                }

                appRouter.navigate('show/resetPasswordByPhone', { trigger: true });
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

    getBindQuestion: function() {
        var m = new GETModal();
        m.urlRoot = apiRootUrl + 'question?username=' + encodeURIComponent(username) + "&language=" + languageIndex;
        m.fetch({
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                if (response.length < 3) {
                    $('#ddl_modal_title').text(ddlText.nobind_question[languageIndex]);
                    showDialog();
                    return;
                }

                q0 = response[0].QuestionName;
                q1 = response[1].QuestionName;
                q2 = response[2].QuestionName;

                qid0 = response[0].QuestionId;
                qid1 = response[1].QuestionId;
                qid2 = response[2].QuestionId;

                appRouter.navigate('show/resetPasswordByQuestion', { trigger: true });
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

});


//通过手机重置密码界面
var ResetPasswordByPhoneView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_resetPasswordByPhone').html()),

    events: {
        'click #resetPasswordByPhone_btn_getIdentifyCode': 'getPhoneCode',
        'click #resetPasswordByPhone_send_to_server': 'sendToServer',
        'input #resetPasswordByPhone_input_identifyCode': 'limit'
    },

    render: function() {
        this.$el.html(this.template);

        titleContact.set({
            titleTamplateTitle: ddlText.reset_pwd[languageIndex],
            titleTamplateBackHtml: ''
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByPhone_btn_clearPassword1" placeholder="' + ddlText.new_pwd[languageIndex]+"("+ddlText.pwd_limit[languageIndex]+")" + '" title="new"',
            inputTamplateBtnId: 'resetPasswordByPhone_btn_clearPassword',
//            inputTamplateInputPromptId: 'resetPasswordByPhone_btn_clearPassword1_prompt'
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#resetPasswordByPhone_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#resetPasswordByPhone_div_password')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
//            inputTamplateInputHtml: 'type="password" id="resetPasswordByPhone_btn_clearConfirmPassword1" placeholder="' + ddlText.confirm_pwd[languageIndex] +"("+ddlText.pwd_equal[languageIndex]+")"+ '" title="new"',
             inputTamplateInputHtml: 'type="password" id="resetPasswordByPhone_btn_clearConfirmPassword1" placeholder="' +ddlText.pwd_equal[languageIndex]+ '" title="new"',
            inputTamplateBtnId: 'resetPasswordByPhone_btn_clearConfirmPassword',
//            inputTamplateInputPromptId: 'resetPasswordByPhone_btn_clearConfirmPassword1_prompt'
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#resetPasswordByPhone_div_confirmPassword')).append(inputTamplateView2.render().el);

//        $('#resetPasswordByPhone_btn_clearPassword1_prompt').text(ddlText.pwd_limit[languageIndex]);
//        $('#resetPasswordByPhone_btn_clearConfirmPassword1_prompt').text(ddlText.pwd_equal[languageIndex]);

        $('#resetPasswordByPhone_input_identifyCode').attr('placeholder', ddlText.code[languageIndex]);
        $('#resetPasswordByPhone_btn_getIdentifyCode').text(ddlText.get_code[languageIndex]);
        $('#resetPasswordByPhone_send_to_server').text(ddlText.submit[languageIndex]);

        var imgInput = '<div class="panel panel-default"><div class="panel-body"><div class="input-group"><span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span><input class="form-control" id="ddl_input_imgCode" placeholder="验证码"><span class="input-group-btn ddl_input_span"><img id="ddl_img_imgCode"></span></div></div></div>';

        modalContact.set({
            modalTamplate_title: '请输入图片验证码',
            modalTamplate_body: imgInput,
            modalTamplate_ok: ddlText.confirm[languageIndex],
            modalTamplate_okid: 'ddl_imgCode_ok',
            modalTamplate_cancelid: 'ddl_imgCode_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });

        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);
        $('.ddl_btn_ok').attr('name', '4');
        $('#ddl_img_imgCode').bind('click', function() { getImgCode(); });
        getImgCode();
        //$('.ddl_btn_close').hide();
        return this;
    },

    getPhoneCode: function() {
        if (isCanGetIdentify) {
            if (isPhoneImgCode) {
                getImgCode();
                showDialog();
            } else {
                resetPwdByPhoneSendCode();
            }
        }
    },

    limit: function(e) {
        $('#' + e.currentTarget.id).val($('#' + e.currentTarget.id).val());
        limitInputLength($('#' + e.currentTarget.id), 6);
    },

    sendToServer: function() {
        var code = '#resetPasswordByPhone_input_identifyCode';
        var password1 = '#resetPasswordByPhone_btn_clearPassword1';
        var password2 = '#resetPasswordByPhone_btn_clearConfirmPassword1';

        if (validateIdentifyCode(code) && validatePassword(password1) && validateConfirmPassword(password1, password2)) {
            var identifyCode = $(code).val();
            var pwmd5 = $.md5($(password1).val());

            var vm = new validateCodeModal();
            vm.set({
                UserName: username,
                Code: identifyCode
            });
            console.log(JSON.stringify(vm));
            vm.save(null, {
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                    var passwordToken = response.Token;
                    var m = new ResetPasswordModal();
                    m.set({
                        UserName: username,
                        Token: passwordToken,
                        Password: pwmd5
                    });
                    console.log(JSON.stringify(m));
                    ddlSDK.showLoading();
                    m.save(null, {
                        success: function(model, response) {
                            ddlSDK.hideLoading();
                            console.log(response);
                            if (isReplyError(response.Message, response.Code)) {
                                //页面还原
                                if ($('#resetPasswordByPhone_btn_getIdentifyCode').text() == ddlText.resend_code[languageIndex]) {
                                    $('#resetPasswordByPhone_btn_getIdentifyCode').text(ddlText.get_code[languageIndex]);
                                } else {
                                    timerSet0 = true;
                                    identify_wait = 0;
                                }
                                $('#resetPasswordByPhone_btn_clearPassword').empty();
                                $('#resetPasswordByPhone_btn_clearConfirmPassword').empty();
                                $(code).val('');
                                $(password1).val('');
                                $(password2).val('');
                                isCanGetIdentify = true;
                                return;
                            }
                            toastr.success(ddlText.reset_suc[languageIndex]);

                            password = '';
                            ddlSDK.saveValue('username', username);
                            ddlSDK.saveValue('pwMD5', '');
                            ddlSDK.saveAccountHistory();

                            for (var i = 0; i < all_userMessage.length; i++) {
                                if (username == all_userMessage[i].username) {
                                    all_userMessage[i].pwMD5 = '';
                                    break;
                                }
                            }

                            appRouter.navigate('show/login', { trigger: true });
                        },
                        error: function(err) {
                            ddlSDK.hideLoading();
                            requestFailed();
                        }
                    });
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }
    },

});

function resetPwdByPhoneSendCode() {
    isCanGetIdentify = false;
    var m = new GETModal();
    if (isPhoneImgCode) {
        m.urlRoot = apiRootUrl + 'security/phonenumbercode?username=' + encodeURIComponent(username) + '&sessionid=' + deviceId + '&tokenid=' + imgCodeToken + "&language=" + languageIndex;
    } else {
        m.urlRoot = apiRootUrl + 'security/phonenumbercode?username=' + encodeURIComponent(username) + "&language=" + languageIndex;
    }

    m.fetch({
        success: function(model, response) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            console.log(response);
            //10001未绑定手机号，10002用户名不存在
            if (isReplyError(response.Message, response.Code)) {
                return;
            }
            toastr.success(ddlText.sended_code[languageIndex]);
            getIdentifyCode('#resetPasswordByPhone_btn_getIdentifyCode');
        },
        error: function(err) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            requestFailed();
        }
    });
}

var questionId0, questionId1; //显示的两个问题的ID
var questionToken;

var ResetPasswordByQuestionView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_resetPasswordByQuestion').html()),

    events: {
        'click #resetPasswordByQuestion_send_to_server': 'sendToServer',
    },

    render: function() {
        this.$el.html(this.template());

        titleContact.set({
            titleTamplateTitle: ddlText.input_answer[languageIndex],
            titleTamplateBackHtml: ''
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="resetPasswordByQuestion_div_clearAnswer01" placeholder="' + ddlText.answer[languageIndex] + '"',
            inputTamplateBtnId: 'resetPasswordByQuestion_div_clearAnswer0',
            inputTamplateInputPromptId: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#resetPasswordByQuestion_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#resetPasswordByQuestion_div_answer0')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="resetPasswordByQuestion_div_clearAnswer11" placeholder="' + ddlText.answer[languageIndex] + '"',
            inputTamplateBtnId: 'resetPasswordByQuestion_div_clearAnswer1',
            inputTamplateInputPromptId: ''
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#resetPasswordByQuestion_div_answer1')).append(inputTamplateView2.render().el);

        var r1 = Math.floor(Math.random() * 3) + 1;
        if (r1 == 1) {
            $('#resetPasswordByQuestion_question_one').text(q0);
            questionId0 = qid0;
        } else if (r1 == 2) {
            $('#resetPasswordByQuestion_question_one').text(q1);
            questionId0 = qid1;
        } else if (r1 == 3) {
            $('#resetPasswordByQuestion_question_one').text(q2);
            questionId0 = qid2;
        }
        var r2 = Math.floor(Math.random() * 3) + 1;
        while (r2 == r1){
            r2 = Math.floor(Math.random() * 3) + 1;
        }
        if (r2 == 1) {
            $('#resetPasswordByQuestion_question_two').text(q0);
            questionId1 = qid0;
        } else if (r2 == 2) {
            $('#resetPasswordByQuestion_question_two').text(q1);
            questionId1 = qid1;
        } else if (r2 == 3) {
            $('#resetPasswordByQuestion_question_two').text(q2);
            questionId1 = qid2;
        }

        $('#resetPasswordByQuestion_send_to_server').text(ddlText.next[languageIndex]);
       // $('.ddl_btn_close').hide();
        return this;
    },

    sendToServer: function() {
        if (input_be_null('#resetPasswordByQuestion_div_clearAnswer01') && input_be_null('#resetPasswordByQuestion_div_clearAnswer11') && this.check_be_same()) {
            var answer0 = $('#resetPasswordByQuestion_div_clearAnswer01').val();
            var answer1 = $('#resetPasswordByQuestion_div_clearAnswer11').val();

            var m = new ValidateQuestionModal();
            m.set({
                UserName: username,
                QuestionAnswer: [{
                    QuestionId: questionId0,
                    Answer: $.md5(answer0)
                }, {
                    QuestionId: questionId1,
                    Answer: $.md5(answer1)
                }]
            });

            console.log(JSON.stringify(m));
            ddlSDK.showLoading();

            m.save(null, {
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                    questionToken = response.Token;
                    appRouter.navigate('show/resetPasswordByQuestionNext', { trigger: true });
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }
    },

    check_be_same: function() {
        var answer1 = $('#resetPasswordByQuestion_div_clearAnswer01').val();
        var answer2 = $('#resetPasswordByQuestion_div_clearAnswer11').val();
        if (answer1 == answer2) {
            toastr.error(ddlText.answer_equal[languageIndex]);
            return false;
        } else {
            return true;
        }
    }

});

//通过密保修改密码的下一界面
var ResetPasswordByQuestionNextView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_resetPasswordByQuestionNext').html()),

    events: {
        'click #resetpasswordByQuestion_next_btn_reset': 'sendToServer',
    },

    render: function() {
        this.$el.html(this.template());

        titleContact.set({
            titleTamplateTitle: ddlText.reset_pwd[languageIndex],
            titleTamplateBackHtml: ''
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByQuestionNext_btn_clearPassword1" placeholder="' + ddlText.new_pwd[languageIndex] +"("+ddlText.pwd_limit[languageIndex]+")" + '" title="new"',
            inputTamplateBtnId: 'resetPasswordByQuestionNext_btn_clearPassword',
//            inputTamplateInputPromptId: 'resetPasswordByQuestionNext_btn_clearPassword1_prompt'
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#resetPasswordByQuestionNext_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#resetPasswordByQuestionNext_div_password')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByQuestionNext_btn_clearConfirmPassword1" placeholder="' + ddlText.pwd_equal[languageIndex]+ '" title="new"',
            inputTamplateBtnId: 'resetPasswordByQuestionNext_btn_clearConfirmPassword',
//            inputTamplateInputPromptId: 'resetPasswordByQuestionNext_btn_clearConfirmPassword1_prompt'
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#resetPasswordByQuestionNext_div_confirmPassword')).append(inputTamplateView2.render().el);

//        $('#resetPasswordByQuestionNext_btn_clearPassword1_prompt').text(ddlText.pwd_limit[languageIndex]);
//        $('#resetPasswordByQuestionNext_btn_clearConfirmPassword1_prompt').text(ddlText.pwd_equal[languageIndex]);

        $('#resetpasswordByQuestion_next_btn_reset').text(ddlText.submit[languageIndex]);
        //$('.ddl_btn_close').hide();
        return this;
    },

    sendToServer: function() {
        var password1 = '#resetPasswordByQuestionNext_btn_clearPassword1';
        var password2 = '#resetPasswordByQuestionNext_btn_clearConfirmPassword1';

        if (validatePassword(password1) && validateConfirmPassword(password1, password2)) {
            var pwmd5 = $.md5($(password1).val());

            var m = new ResetPasswordModal();
            m.set({
                UserName: username,
                Token: questionToken,
                Password: pwmd5
            });
            console.log(JSON.stringify(m));
            ddlSDK.showLoading();
            m.save(null, {
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                    toastr.success(ddlText.reset_suc[languageIndex]);

                    password = '';
                    ddlSDK.saveValue('username', username);
                    ddlSDK.saveValue('pwMD5', '');
                    ddlSDK.saveAccountHistory();

                    for (var i = 0; i < all_userMessage.length; i++) {
                        if (username == all_userMessage[i].username) {
                            all_userMessage[i].pwMD5 = '';
                            break;
                        }
                    }

                    appRouter.navigate('show/login', { trigger: true });
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }
    },

});

//用户中心
var UserCenterView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_userCenter').html()),
    right_span: '<span class="glyphicon glyphicon-chevron-right view_right"></span>',

    events: {
        'click #userCenter_to_modify_password': 'to_modify_password',
        'click #userCenter_to_bind_phone': 'to_bind_phone',
        'click #userCenter_to_bind_question': 'to_bind_question',
        'click #userCenter_clear_account': 'clear_account'
    },

    render: function() {
        this.$el.html(this.template());
        titleContact.set({
            titleTamplateTitle: ddlText.usercenter[languageIndex],
            titleTamplateBackHtml: 'hidden '
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#userCenter_nav_title')).append(titleTamplateView.render().el);

        ddlSDK.setApp();

        console.log("用户信息->    username->" + userInfo.username + "    token->" + userInfo.token + "    expire->" + userInfo.expire + "    bindType->" + userInfo.bindType);
        loginToBind = false;

        var bindPhoneMsg = '';
        var bindQuestionMsg = '';
        var ddl_bind_phone_color = '';
        var ddl_bind_question_color = '';
        modalContact.set({
            modalTamplate_title: ddlText.prompt[languageIndex],
            modalTamplate_body: ddlText.is_logout[languageIndex],
            modalTamplate_ok: ddlText.confirm[languageIndex],
            modalTamplate_okid: 'userCenter_modal2_logout_ok',
            modalTamplate_cancelid: 'userCenter_modal2_logout_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });
        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);

        $('#userCenter_clear_account').text(ddlText.logout[languageIndex]);
        $('#userCenter_to_modify_password').html(ddlText.change_pwd[languageIndex] + this.right_span);

        $('#userCenter_to_bind_phone').html('<div style="float:left">' + ddlText.bind_phone[languageIndex] + '</div>' + this.right_span);
        $('#userCenter_to_bind_question').html('<div style="float:left">' + ddlText.bind_question[languageIndex] + '</div>' + this.right_span);

        if (userInfo.userType >= USERTYPE_SINA && userInfo.userType <= USERTYPE_VISITOR) {
            $('#userCenter_account').text(ddlText.visitor[languageIndex] + ':' + userInfo.username);
            $('#userCenter_clear_account').text(ddlText.bind_account[languageIndex]);
        } else {
            if (userInfo.bindType == BINDTYPE_ALL) {
                $('#userCenter_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>&nbsp;&nbsp;&nbsp;' + '<span>' + ddlText.security_level[languageIndex] + '：</span>' + '<span style="color:green;font-weight:bold;">' + ddlText.high[languageIndex] + '</span>');
            } else if (userInfo.bindType == BINDTYPE_NULL) {
                $('#userCenter_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>&nbsp;&nbsp;&nbsp;' + '<span>' + ddlText.security_level[languageIndex] + '：</span>' + '<span style="color:red;font-weight:bold;">' + ddlText.low[languageIndex] + '</span>');
            } else {
                $('#userCenter_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>&nbsp;&nbsp;&nbsp;' + '<span>' + ddlText.security_level[languageIndex] + '：</span>' + '<span style="color:orange;font-weight:bold;">' + ddlText.mid[languageIndex] + '</span>');
            }
            if (userInfo.bindType == BINDTYPE_PHONE || userInfo.bindType == BINDTYPE_ALL){
                bindPhoneMsg = ddlText.bind_yes[languageIndex];
                ddl_bind_phone_color = 'green';
            }
            else{
                bindPhoneMsg = ddlText.bind_no[languageIndex];
                ddl_bind_phone_color = 'red';
            }
            if (userInfo.bindType == BINDTYPE_ANSWER || userInfo.bindType == BINDTYPE_ALL) {
                bindQuestionMsg = ddlText.bind_yes[languageIndex];
                ddl_bind_question_color = 'green';
            } else {
                bindQuestionMsg = ddlText.bind_no[languageIndex];
                ddl_bind_question_color = 'red';
            }

            $('#userCenter_to_bind_phone').html('<div style="float:left">' + ddlText.bind_phone[languageIndex] + '</div>' + this.right_span + '<div class="ddl_bind_state view_right" id="userCenter_div_bindPhone" style="color:' + ddl_bind_phone_color + ';">(' + bindPhoneMsg + ')</div>');
            $('#userCenter_to_bind_question').html('<div style="float:left">' + ddlText.bind_question[languageIndex] + '</div>' + this.right_span + '<div class="ddl_bind_state view_right" style="color:' + ddl_bind_question_color + ';">(' + bindQuestionMsg + ')</div>');
        }

        if (userInfo.bindType == BINDTYPE_PHONE || userInfo.bindType == BINDTYPE_ALL) {
            ddlSDK.showLoading();
            var m = new GETModal();
            m.urlRoot = apiRootUrl + 'security/userphonenumber?uid=' + userInfo.uid + '&token=' + userInfo.token + "&language=" + languageIndex;
            m.fetch({
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (response.Code != undefined && response.Code == 10000 && response.Message != undefined) {
                        return;
                    }
                    if (response.PhoneNumber != '') {
                        $('#userCenter_div_bindPhone').html('(' + ddlText.bind_yes[languageIndex] + ',' + response.PhoneNumber + ')');
                    }
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }

        if (phoneRegister_switch == '1') {
            $('#userCenter_to_bind_phone').hide();
        }

        return this;
    },

    to_modify_password: function() {
        var showPage = '';
        if (userInfo.userType >= USERTYPE_SINA && userInfo.userType <= USERTYPE_VISITOR) {
            toastr.info(ddlText.visitor_should_bind[languageIndex]);
        } else {
            showPage = 'resetPasswordByPassword';
            appRouter.navigate('show/' + showPage, { trigger: true });
        }
    },

    to_bind_phone: function() {
        var showPage = '';
        if (userInfo.userType >= USERTYPE_SINA && userInfo.userType <= USERTYPE_VISITOR) {
            toastr.info(ddlText.visitor_should_bind[languageIndex]);
        } else if (userInfo.bindType == BINDTYPE_PHONE || userInfo.bindType == BINDTYPE_ALL) {
            showPage = 'unbindPhone';
        } else {
            showPage = 'validatePassword';
            bindIndex = 0;
        }
        if (showPage != '') {
            appRouter.navigate('show/' + showPage, { trigger: true });
        }
    },

    to_bind_question: function() {
        var showPage = '';
        if (userInfo.userType >= USERTYPE_SINA && userInfo.userType <= USERTYPE_VISITOR) {
            toastr.info(ddlText.visitor_should_bind[languageIndex]);
        } else if (userInfo.bindType == BINDTYPE_ANSWER || userInfo.bindType == BINDTYPE_ALL) {
            showPage = 'unbindQuestion';
        } else {
            showPage = 'validatePassword';
            bindIndex = 1;
        }

        if (showPage != '') {
            appRouter.navigate('show/' + showPage, { trigger: true });
        }
    },

    clear_account: function() {
        if (userInfo.userType <= USERTYPE_PHONE || userInfo.userType == USERTYPE_NOIDCARD) {
            showDialog();
        } else {
            if (phoneRegister_switch == '1') {
                appRouter.navigate('show/registerByUsername', { trigger: true });
            } else {
                appRouter.navigate('show/registerByPhone', { trigger: true });
            }
        }
    }
});

// 使用旧密码修改密码
var ResetPasswordByPasswordView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_resetPasswordByPassword').html()),

    events: {
        'click #resetPasswordByPassword_btn_reset': 'resetPassword',
    },

    render: function() {
        this.$el.html(this.template);

        titleContact.set({
            titleTamplateTitle: ddlText.reset_pwd[languageIndex],
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByPassword_btn_clearOldPassword1" placeholder="' + ddlText.old_pwd[languageIndex] + '"',
            inputTamplateBtnId: 'resetPasswordByPassword_btn_clearOldPassword',
            inputTamplateInputPromptId: ''
        });

        if (isLoginChangePassword) {
            titleContact.set({
                titleTamplateBackHtml: 'hidden '
            });
        } else {
            titleContact.set({
                titleTamplateBackHtml: ''
            });
        }
        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#resetPasswordByPassword_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#resetPasswordByPassword_div_oldPassword')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByPassword_btn_clearPassword1" placeholder="' + ddlText.new_pwd[languageIndex] +"("+ddlText.pwd_limit[languageIndex]+")"+ '" title="new"',
            inputTamplateBtnId: 'resetPasswordByPassword_btn_clearPassword',
//            inputTamplateInputPromptId: 'resetPasswordByPassword_btn_clearPassword1_prompt'
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#resetPasswordByPassword_div_password')).append(inputTamplateView2.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="resetPasswordByPassword_btn_clearConfirmPassword1" placeholder="' + ddlText.pwd_equal[languageIndex] + '" title="new"',
            inputTamplateBtnId: 'resetPasswordByPassword_btn_clearConfirmPassword',
//            inputTamplateInputPromptId: 'resetPasswordByPassword_btn_clearConfirmPassword1_prompt'
        });

        var inputTamplateView3 = new InputTamplateView();
        this.$el.find($('#resetPasswordByPassword_div_confirmPassword')).append(inputTamplateView3.render().el);

//        $('#resetPasswordByPassword_btn_clearPassword1_prompt').text(ddlText.pwd_limit[languageIndex]);
//        $('#resetPasswordByPassword_btn_clearConfirmPassword1_prompt').text(ddlText.pwd_equal[languageIndex]);

        $('#resetPasswordByPassword_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>');

        $('#resetPasswordByPassword_btn_reset').text(ddlText.submit[languageIndex]);

        return this;
    },

    resetPassword: function() {
        var input_oldPassword = '#resetPasswordByPassword_btn_clearOldPassword1';
        var input_newPassword = '#resetPasswordByPassword_btn_clearPassword1';
        var input_newClearPassword = '#resetPasswordByPassword_btn_clearConfirmPassword1';

        if (input_be_null(input_oldPassword) && validatePassword(input_newPassword) && validateConfirmPassword(input_newPassword, input_newClearPassword)) {
            var npassword = $(input_newPassword).val();
            var npwMD5 = $.md5(npassword);
            var opassword = $(input_oldPassword).val();
            var opwMD5 = $.md5(opassword);

            var vm = new ResetPasswordByPasswordModal();
            vm.set({
                UId: userInfo.uid,
                Token: userInfo.token,
                NewPassword: npwMD5,
                OldPassword: opwMD5
            });
            console.log(JSON.stringify(vm));
            vm.save(null, {
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                    toastr.success(ddlText.reset_suc[languageIndex]);
                    userInfo.token = response.Token;
                    ddlSDK.saveValue('pwMD5', npwMD5);
                    ddlSDK.updateUserInfo();
                    ddlSDK.bindSuccessCallback('1','1');
                    ddlSDK.saveAccountHistory();

                    if (isLoginChangePassword) {
                        ddlSDK.closePage();
                    } else {
                        appRouter.navigate('show/userCenter', { trigger: true });
                    }
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }
    }
});


var validatePasswordToken;

//验证密码
var ValidatePasswordView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_validatePassword').html()),

    events: {
        'click #validatePassword_btn_next': 'bindNext',
    },

    render: function() {
        this.$el.html(this.template);

        var bs = '';
        if (loginToBind) {
            bs = 'hidden ';
        }

        var ts = '';
        if (bindIndex == 0) {
            ts = ddlText.bind_phone[languageIndex];
        } else if (bindIndex == 1) {
            ts = ddlText.bind_question[languageIndex];
        }
        titleContact.set({
            titleTamplateTitle: ts,
            titleTamplateBackHtml: bs
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-asterisk',
            inputTamplateInputHtml: 'type="password" id="validatePassword_btn_clearPassword1" placeholder="' + ddlText.pwd[languageIndex] + '"',
            inputTamplateBtnId: 'validatePassword_btn_clearPassword',
            inputTamplateInputPromptId: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#validatePassword_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#validatePassword_div_password')).append(inputTamplateView.render().el);

        $('#validatePassword_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>');

        $('#validatePassword_btn_next').text(ddlText.next[languageIndex]);
        $('#validatePassword_input_imgCode').text(ddlText.code[languageIndex]);

        $('#validatePassword_panel_imgCode').hide();

        return this;
    },

    bindNext: function() {
        if (input_be_null('#validatePassword_btn_clearPassword1')) {
            var password = $('#validatePassword_btn_clearPassword1').val();
            var pwMD5 = $.md5(password);

            ddlSDK.showLoading();
            this.validatePwdIsTrue(pwMD5);
        }
    },

    validatePwdIsTrue: function(pwMD5) {
        var vm = new validatePasswordModal();
        vm.set({
            UId: userInfo.uid,
            Token: userInfo.token,
            Password: pwMD5
        });
        console.log(JSON.stringify(vm));
        vm.save(null, {
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                validatePasswordToken = response.UpdateToken;
                if (bindIndex == 0) {
                    appRouter.navigate('show/bindPhone', { trigger: true });
                } else if (bindIndex == 1) {
                    appRouter.navigate('show/bindQuestion', { trigger: true });
                }

            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

});

//绑定手机界面
var BindPhoneView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_bindPhone').html()),

    events: {
        'click #bindPhone_btn_bind': 'bind',
        'click #bindPhone_btn_getIdentifyCode': 'getIdentifyCode',
        'input #bindPhone_input_identifyCode': 'limit',
    },

    render: function() {
        this.$el.html(this.template);

        var bs = '';
        if (loginToBind) {
            bs = 'hidden ';
        }
        titleContact.set({
            titleTamplateTitle: ddlText.bind_phone[languageIndex],
            titleTamplateBackHtml: bs
        });

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-phone',
            inputTamplateInputHtml: 'type="number" id="bindPhone_btn_clearPhone1" placeholder="' + ddlText.phone[languageIndex] + '"',
            inputTamplateBtnId: 'bindPhone_btn_clearPhone',
            inputTamplateInputPromptId: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#bindPhone_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#bindPhone_div_phone')).append(inputTamplateView.render().el);

        $('#bindPhone_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>');

        $('#bindPhone_input_identifyCode').attr('placeholder', ddlText.code[languageIndex]);
        $('#bindPhone_btn_getIdentifyCode').text(ddlText.get_code[languageIndex]);
        $('#bindPhone_btn_bind').text(ddlText.bind[languageIndex]);

        var imgInput = '<div class="panel panel-default"><div class="panel-body"><div class="input-group"><span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span><input class="form-control" id="ddl_input_imgCode" placeholder="验证码"><span class="input-group-btn ddl_input_span"><img id="ddl_img_imgCode"></span></div></div></div>';

        modalContact.set({
            modalTamplate_title: '请输入图片验证码',
            modalTamplate_body: imgInput,
            modalTamplate_ok: ddlText.confirm[languageIndex],
            modalTamplate_okid: 'ddl_imgCode_ok',
            modalTamplate_cancelid: 'ddl_imgCode_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });

        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);
        $('.ddl_btn_ok').attr('name', '5');
        $('#ddl_img_imgCode').bind('click', function() { getImgCode(); });
        getImgCode();

        return this;
    },

    bind: function() {
        var input_identifyCode = '#bindPhone_input_identifyCode';
        var input_phone = '#bindPhone_btn_clearPhone1';

        if (validatePhone(input_phone) && validateIdentifyCode(input_identifyCode)) {
            var identifyCode = $(input_identifyCode).val();
            phone = $(input_phone).val();

            //绑定手机
            var bm = new BindPhoneModal();
            bm.set({
                UId: userInfo.uid,
                UpdateToken: validatePasswordToken,
                Code: identifyCode,
                PhoneNumber: phone
            });

            console.log(JSON.stringify(bm));
            bm.save(null, {
                success: function(model, response) {
                    ddlSDK.hideLoading();
                    console.log(response);
                    if (isReplyError(response.Message, response.Code)) {
                        return;
                    }
                    if (userInfo.bindType == BINDTYPE_ANSWER) {
                        userInfo.bindType = BINDTYPE_ALL;
                    } else if (userInfo.bindType == BINDTYPE_NULL) {
                        userInfo.bindType = BINDTYPE_PHONE;
                    }
                    ddlSDK.updateUserInfo();

                    var s1;
                    var s2 = '<span class="ddl_css_modal_content_left">' + ddlText.account[languageIndex] + '：</span>' + userInfo.username + '</br><span class="ddl_css_modal_content_left">' + ddlText.phone[languageIndex] + '：</span>' + phone + '<h5 style="text-align:center"><b>' + ddlText.bind_yes[languageIndex] + '</b></h5>';
                    if (userInfo.bindType == BINDTYPE_PHONE) {
                        s1 = ddlText.security_level[languageIndex] + '：' + ddlText.mid[languageIndex];
                    } else {
                        s1 = ddlText.security_level[languageIndex] + '：' + ddlText.high[languageIndex];
                    }
                    modalContact.set({
                        modalTamplate_title: s1,
                        modalTamplate_body: s2,
                        modalTamplate_okid: 'bindPhone_modal1_bindOk',
                        modalTamplate_ok: ddlText.finish[languageIndex]
                    });
                    var mt = new modalTamplate1View();
                    $('#ddl_modal_dialog').html(mt.render().el);
                    $('#ddl_modal_body').removeClass('ddl_css_modal_body');

                    showDialog();
                },
                error: function(err) {
                    ddlSDK.hideLoading();
                    requestFailed();
                }
            });
        }
    },

    getIdentifyCode: function() {
        if (isCanGetIdentify && validatePhone('#bindPhone_btn_clearPhone1')) {
            phone = $('#bindPhone_btn_clearPhone1').val();
            if (isPhoneImgCode) {
                getImgCode();
                showDialog();
            } else {
                ddlSDK.getDesString(phone, 'bindPhoneGetPhoneDesCallback');
            }
        }
    },

    limit: function(e) {
        $('#' + e.currentTarget.id).val($('#' + e.currentTarget.id).val());
        limitInputLength($('#' + e.currentTarget.id), 6);
    }
});

function bindPhoneGetPhoneDesCallback(phoneDes) {
    isCanGetIdentify = false;
    var m = new GETModal();
    phoneDes = phoneDes.replace(/\+/g, "-");
    phoneDes = phoneDes.replace(/\//g, "_");
    phoneDes = phoneDes.replace(/\=/g, "~");
    ddlSDK.showLoading();

    if (isPhoneImgCode) {
        m.urlRoot = apiRootUrl + 'sms/' + phoneDes + '?sessionid=' + deviceId + '&tokenid=' + imgCodeToken + "&language=" + languageIndex;
    } else {
        m.urlRoot = apiRootUrl + 'sms/' + phoneDes + "?language=" + languageIndex;
    }
    console.log(m.urlRoot);
    m.fetch({
        success: function(model, response) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            console.log(response);
            if (isReplyError(response.Message, response.Code)) {
                return;
            }
            toastr.success(ddlText.sended_code[languageIndex]);
            getIdentifyCode('#bindPhone_btn_getIdentifyCode');
        },
        error: function(err) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            requestFailed();
        }
    });
}

//解绑手机界面
var UnbindPhoneView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_unbindPhone').html()),

    events: {
        'click #unbindPhone_btn_unbind': 'unbind',
        'click #unbindPhone_btn_getIdentifyCode': 'getIdentifyCode',
        'input #unbindPhone_input_identifyCode': 'limit',
        'click #unbindPhone_img_imgCode': 'getImgCode'
    },

    render: function() {
        this.$el.html(this.template);

        titleContact.set({
            titleTamplateTitle: ddlText.unbind_phone[languageIndex],
            titleTamplateBackHtml: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#unbindPhone_nav_title')).append(titleTamplateView.render().el);

        $('#unbindPhone_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>');

        $('#unbindPhone_input_identifyCode').attr('placeholder', ddlText.code[languageIndex]);
        $('#unbindPhone_btn_getIdentifyCode').text(ddlText.get_code[languageIndex]);
        $('#unbindPhone_btn_unbind').text(ddlText.unbind[languageIndex]);
        $('.ddl_prompt_msg').html('<span class="glyphicon glyphicon-info-sign"></span> ' + ddlText.phone_unuse[languageIndex]);

        $('#unbindPhone_panel_imgCode').hide();
        getImgCode();

        return this;
    },

    unbind: function() {
        if (validateIdentifyCode('#unbindPhone_input_identifyCode')) {
            modalContact.set({
                modalTamplate_title: ddlText.unbind_phone[languageIndex],
                modalTamplate_body: ddlText.is_unbind_phone[languageIndex],
                modalTamplate_ok: ddlText.unbind[languageIndex],
                modalTamplate_okid: 'unbindPhone_modal_ok',
                modalTamplate_cancelid: 'unbindPhone_modal_cancel',
                modalTamplate_cancel: ddlText.cancel[languageIndex]
            });
            var mt = new modalTamplate2View();
            $('#ddl_modal_dialog').html(mt.render().el);
            $('.ddl_btn_ok').attr('name', '0');
            showDialog();
        }
    },

    getIdentifyCode: function() {
        if (isCanGetIdentify) {
            if (isPhoneImgCode) {
                var imgInput = '<div class="panel panel-default"><div class="panel-body"><div class="input-group"><span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span><input class="form-control" id="ddl_input_imgCode" placeholder="验证码"><span class="input-group-btn ddl_input_span"><img id="ddl_img_imgCode"></span></div></div></div>';
                modalContact.set({
                    modalTamplate_title: '请输入图片验证码',
                    modalTamplate_body: imgInput,
                    modalTamplate_ok: ddlText.confirm[languageIndex],
                    modalTamplate_okid: 'ddl_imgCode_ok',
                    modalTamplate_cancelid: 'ddl_imgCode_cancel',
                    modalTamplate_cancel: ddlText.cancel[languageIndex]
                });

                var mt = new modalTamplate2View();
                $('#ddl_modal_dialog').html(mt.render().el);
                $('.ddl_btn_ok').attr('name', '6');
                $('#ddl_img_imgCode').bind('click', function() { getImgCode(); });

                getImgCode();
                showDialog();
            } else {
                unbindPhoneSendCode();
            }
        }
    },

    limit: function(e) {
        $('#' + e.currentTarget.id).val($('#' + e.currentTarget.id).val());
        limitInputLength($('#' + e.currentTarget.id), 6);
    },

});

function unbindPhoneSendCode() {
    isCanGetIdentify = false;
    //用户名获取验证码
    var m = new GETModal();
    if (isPhoneImgCode) {
        m.urlRoot = apiRootUrl + 'security/unbindcode?uid=' + userInfo.uid + '&token=' + userInfo.token + '&sessionid=' + deviceId + '&tokenid=' + imgCodeToken + "&language=" + languageIndex;
    } else {
        m.urlRoot = apiRootUrl + 'security/unbindcode?uid=' + userInfo.uid + '&token=' + userInfo.token + "&language=" + languageIndex;
    }

    m.fetch({
        success: function(model, response) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            console.log(response);
            if (isReplyError(response.Message, response.Code)) {
                return;
            }
            toastr.success(ddlText.sended_code[languageIndex]);
            getIdentifyCode('#unbindPhone_btn_getIdentifyCode');
        },
        error: function(err) {
            isCanGetIdentify = true;
            ddlSDK.hideLoading();
            requestFailed();
        }
    });
}

//绑定密保问题界面
var BindQuestionView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_bindQuestion').html()),
    clickedButtonId: '',
    clickedButtonIndex: 0,
    qid: null, //存放问题id

    events: {
        'click #bindQuestion_submit': 'questionSubmit',
        'click .bindQuestion_li_btn': 'selectQuestion',
        'click .ddl_css_btn_questionDropdown': 'showQuestion',
        'click #bindQuestion_gray_bg': 'hideQuestion'
    },

    render: function() {
        this.$el.html(this.template);
        this.qid = new Array(3);

        titleContact.set({
            titleTamplateTitle: ddlText.bind_question[languageIndex],
            titleTamplateBackHtml: ''
        });
        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="bindQuestion_div_clearAnswer01" placeholder="' + ddlText.answer[languageIndex] +"("+ddlText.answer_limit[languageIndex]+")"+ '"',
            inputTamplateBtnId: 'bindQuestion_div_clearAnswer0',
//            inputTamplateInputPromptId: 'bindQuestion_div_clearAnswer01_prompt'
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#bindQuestion_nav_title')).append(titleTamplateView.render().el);

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#bindQuestion_div_answer0')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="bindQuestion_div_clearAnswer11" placeholder="' + ddlText.answer[languageIndex] +"("+ddlText.answer_limit[languageIndex]+")"+ '"',
            inputTamplateBtnId: 'bindQuestion_div_clearAnswer1',
//            inputTamplateInputPromptId: 'bindQuestion_div_clearAnswer11_prompt'
        });

        var inputTamplateView1 = new InputTamplateView();
        this.$el.find($('#bindQuestion_div_answer1')).append(inputTamplateView1.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="bindQuestion_div_clearAnswer21" placeholder="' + ddlText.answer[languageIndex]+"("+ddlText.answer_limit[languageIndex]+")" + '"',
            inputTamplateBtnId: 'bindQuestion_div_clearAnswer2',
//            inputTamplateInputPromptId: 'bindQuestion_div_clearAnswer21_prompt'
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#bindQuestion_div_answer2')).append(inputTamplateView2.render().el);

//        $('#bindQuestion_div_clearAnswer01_prompt').text(ddlText.answer_limit[languageIndex]);
//        $('#bindQuestion_div_clearAnswer11_prompt').text(ddlText.answer_limit[languageIndex]);
//        $('#bindQuestion_div_clearAnswer21_prompt').text(ddlText.answer_limit[languageIndex]);

        //存放QuestionModal数组
        var q;
        ddlSDK.showLoading();
        var m = new GETModal();
        m.urlRoot = apiRootUrl + 'question?language=' + languageIndex;
        console.log(m.urlRoot);
        m.fetch({
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                var len = response.length;
                q = new Array(len);

                for (var i = 0; i < len; i++) {
                    var qm = new QuestionModal({
                        QuestionId: response[i].QuestionId,
                        QuestionName: response[i].QuestionName,
                        QuestionState: response[i].QuestionState
                    });
                    q[i] = qm;
                }

                //存放li的html
                var lis = document.createDocumentFragment();
                for (var i = 0; i < q.length; i++) {
                    var li = document.createElement('li');
                    var btn = document.createElement('button');

                    li.className = 'list-group-item';
                    btn.type = 'button';
                    btn.className = 'btn bindQuestion_li_btn';
                    btn.tabIndex = q[i].get('QuestionId');
                    btn.appendChild(document.createTextNode(q[i].get('QuestionName')));

                    li.appendChild(btn);
                    lis.appendChild(li);
                }
                $('#bindQuestion_div_question ul').append(lis);
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });

        $('#bindQuestion_account').html(ddlText.account[languageIndex] + '：<span id="bindQuestion_account_username">' + userInfo.username + '</sapn>');

        $('.ddl_css_btn_questionDropdown').html(ddlText.no_select_question[languageIndex] + '<span class="glyphicon glyphicon-chevron-down view_right"></span>');
        $('#bindQuestion_submit').text(ddlText.submit[languageIndex]);
        this.hideQuestion();

        return this;
    },

    selectQuestion: function(e) {
        this.hideQuestion();
        var s = '<span class="glyphicon glyphicon-chevron-down view_right"></span>';
        var question = e.currentTarget.innerText;
        var questionId = e.currentTarget.tabIndex;

        $(this.clickedButtonId).html(question + s);
        this.qid[this.clickedButtonIndex] = questionId;
    },

    questionSubmit: function() {
        var question0 = $("#bindQuest_btn_question0").text();
        var question1 = $("#bindQuest_btn_question1").text();
        var question2 = $("#bindQuest_btn_question2").text();

        var answer0 = $("#bindQuestion_div_clearAnswer01").val();
        var answer1 = $("#bindQuestion_div_clearAnswer11").val();
        var answer2 = $("#bindQuestion_div_clearAnswer21").val();

        if (this.qid[0] == null || this.qid[1] == null || this.qid[2] == null) {
            toastr.error(ddlText.input_null[languageIndex]);
            return;
        }
        if (this.qid[0] == this.qid[1] || this.qid[0] == this.qid[2] || this.qid[1] == this.qid[2]) {
            toastr.error(ddlText.question_select_same[languageIndex]);
            return;
        }
        if (answer0 == '' || answer1 == '' || answer2 == '') {
            toastr.error(ddlText.no_select_question[languageIndex]);
            return;
        }
        if (answer0 == answer1 || answer1 == answer2 || answer0 == answer2) {
            toastr.error(ddlText.answer_equal[languageIndex]);
            return;
        }

        var m = new BindQuestionModal();
        m.set({
            UId: userInfo.uid,
            Token: userInfo.token,
            UpdateToken: validatePasswordToken,
            QuestionAnswer: [{
                QuestionId: this.qid[0],
                Answer: $.md5(answer0)
            }, {
                QuestionId: this.qid[1],
                Answer: $.md5(answer1)
            }, {
                QuestionId: this.qid[2],
                Answer: $.md5(answer2)
            }]
        });
        console.log(JSON.stringify(m));
        ddlSDK.showLoading();

        m.save(null, {
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }
                if (userInfo.bindType == BINDTYPE_PHONE) {
                    userInfo.bindType = BINDTYPE_ALL;
                } else if (userInfo.bindType == BINDTYPE_NULL) {
                    userInfo.bindType = BINDTYPE_ANSWER;
                }
                var s1;
                var s2 = '<span class="ddl_css_modal_content_left">' + ddlText.account[languageIndex] + '：</span><b>' + userInfo.username + '</b></br><span class="ddl_css_modal_content_left">' + ddlText.question[languageIndex] + '1：</span>' + question0 + '</br><span class="ddl_css_modal_content_left">' + ddlText.answer[languageIndex] + '：</span>' + answer0 + '</br><span class="ddl_css_modal_content_left">' + ddlText.question[languageIndex] + '2：</span>' + question1 + '</br><span class="ddl_css_modal_content_left">' + ddlText.answer[languageIndex] + '：</span>' + answer1 + '</br><span class="ddl_css_modal_content_left">' + ddlText.question[languageIndex] + '3：</span>' + question2 + '</br><span class="ddl_css_modal_content_left">' + ddlText.answer[languageIndex] + '：</span>' + answer2 + '<h5 style="text-align:center"><b>' + ddlText.bind_suc[languageIndex] + '！</b></h5>';
                if (userInfo.bindType == BINDTYPE_ANSWER) {
                    s1 = ddlText.security_level[languageIndex] + '：' + ddlText.mid[languageIndex];
                } else {
                    s1 = ddlText.security_level[languageIndex] + '：' + ddlText.high[languageIndex];
                }
                modalContact.set({
                    modalTamplate_title: s1,
                    modalTamplate_body: s2,
                    modalTamplate_okid: 'bindQuestion_modal1_bindOk',
                    modalTamplate_ok: ddlText.finish[languageIndex]
                });
                ddlSDK.updateUserInfo();
                var mt = new modalTamplate1View();

                $('#ddl_modal_dialog').html(mt.render().el);
                $('.dialog_father').addClass('dialog_father_large');
                $('#ddl_modal_body').removeClass('ddl_css_modal_body');
                showDialog();
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });
    },

    showQuestion: function(e) {
        this.clickedButtonId = '#' + e.currentTarget.id;
        this.clickedButtonIndex = e.currentTarget.tabIndex;

        $('#bindQuestion_gray_bg').show();
        $('#bindQuestion_div_question').show();

        //有滚动条的时候
        if ($('#bindQuestion_div_question ul').height() > $('#bindQuestion_div_question').height()) {
            $('body').addClass('overflow_hidden');
        } else {
            $('#bindQuestion_div_question').css('display', 'table');
            $('#bindQuestion_div_question').css('border', 'none');
            $('#bindQuestion_div_question ul').css('display', 'table-cell');
            $('#bindQuestion_div_question ul').addClass('vertical_middel');
        }
    },

    hideQuestion: function() {
        $('#bindQuestion_gray_bg').hide();
        $('#bindQuestion_div_question').hide();
        $('body').removeClass('overflow_hidden');
    }
});

//解绑密保
var UnbindQuestionView = Backbone.View.extend({
    el: $('#ddl_content'),
    template: _.template($('#ddl_unbindQuestion').html()),

    events: {
        'click #unbindQuestion_unbind': 'unBind',
    },

    render: function() {
        this.$el.html(this.template);

        titleContact.set({
            titleTamplateTitle: ddlText.unbind_question[languageIndex],
            titleTamplateBackHtml: ''
        });

        var titleTamplateView = new TitleTamplateView();
        this.$el.find($('#unbindQuestion_nav_title')).append(titleTamplateView.render().el);

        $('#unbindQuestion_account').html('<span>' + ddlText.account[languageIndex] + '：</span><span style="font-weight:bold;">' + userInfo.username + '</span>');

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="unbindQuestion_div_clearAnswer01" placeholder="' + ddlText.answer[languageIndex] + '"',
            inputTamplateBtnId: 'unbindQuestion_div_clearAnswer0',
            inputTamplateInputPromptId: ''
        });

        var inputTamplateView = new InputTamplateView();
        this.$el.find($('#unbindQuestion_div_answer0')).append(inputTamplateView.render().el);

        inputContact.set({
            inputTamplateSpanClass: 'glyphicon-info-sign',
            inputTamplateInputHtml: 'type="text" id="unbindQuestion_div_clearAnswer11" placeholder="' + ddlText.answer[languageIndex] + '"',
            inputTamplateBtnId: 'unbindQuestion_div_clearAnswer1',
            inputTamplateInputPromptId: ''
        });

        var inputTamplateView2 = new InputTamplateView();
        this.$el.find($('#unbindQuestion_div_answer1')).append(inputTamplateView2.render().el);

        ddlSDK.showLoading();
        var m = new GETModal();
        m.urlRoot = apiRootUrl + 'question?username=' + encodeURIComponent(userInfo.username) + "&language=" + languageIndex;
        m.fetch({
            success: function(model, response) {
                ddlSDK.hideLoading();
                console.log(response);
                if (isReplyError(response.Message, response.Code)) {
                    return;
                }

                q0 = response[0].QuestionName;
                q1 = response[1].QuestionName;
                q2 = response[2].QuestionName;

                qid0 = response[0].QuestionId;
                qid1 = response[1].QuestionId;
                qid2 = response[2].QuestionId;

                var r1 = Math.floor(Math.random() * 3) + 1;
                if (r1 == 1) {
                    $('#unbindQuestion_question_one').text(q0);
                    questionId0 = qid0;
                } else if (r1 == 2) {
                    $('#unbindQuestion_question_one').text(q1);
                    questionId0 = qid1;
                } else if (r1 == 3) {
                    $('#unbindQuestion_question_one').text(q2);
                    questionId0 = qid2;
                }
                var r2 = Math.floor(Math.random() * 3) + 1;
                while (r2 == r1) {
                    r2 = Math.floor(Math.random() * 3) + 1;
                }
                if (r2 == 1) {
                    $('#unbindQuestion_question_two').text(q0);
                    questionId1 = qid0;
                } else if (r2 == 2) {
                    $('#unbindQuestion_question_two').text(q1);
                    questionId1 = qid1;
                } else if (r2 == 3) {
                    $('#unbindQuestion_question_two').text(q2);
                    questionId1 = qid2;
                }
            },
            error: function(err) {
                ddlSDK.hideLoading();
                requestFailed();
            }
        });

        modalContact.set({
            modalTamplate_title: ddlText.unbind_question[languageIndex],
            modalTamplate_body: ddlText.is_unbind_question[languageIndex],
            modalTamplate_ok: ddlText.unbind[languageIndex],
            modalTamplate_okid: 'unbindQuestion_modal_ok',
            modalTamplate_cancelid: 'unbindQuestion_modal_cancel',
            modalTamplate_cancel: ddlText.cancel[languageIndex]
        });
        var mt = new modalTamplate2View();
        $('#ddl_modal_dialog').html(mt.render().el);
        $('.ddl_btn_ok').attr('name', '0');

        $('#unbindQuestion_unbind').text(ddlText.unbind[languageIndex]);

        return this;
    },

    unBind: function() {
        if ($('#unbindQuestion_div_clearAnswer01').val() != "" && $('#unbindQuestion_div_clearAnswer11').val() != "") {
            showDialog();
        } else {
            toastr.error(ddlText.input_null[languageIndex]);
        }
    },

    limit: function(e) {
        $('#' + e.currentTarget.id).val($('#' + e.currentTarget.id).val());
        limitInputLength($('#' + e.currentTarget.id), 6);
    }

});

//模态框数据
var ModalContact = Backbone.Model.extend({
    defaults: {
        modalTamplate_title: '',
        modalTamplate_body: '',
        modalTamplate_ok: '',
        modalTamplate_cancel: '',
        modalTamplate_cancelid: '',
        modalTamplate_okid: '',
    }
});

var modalContact = new ModalContact();

//一个按钮的模态框模板
var modalTamplate1View = Backbone.View.extend({
    className: 'modal-content modalTamplate1_css_content',
    template: _.template($('#ddl_modalTamplate1').html()),

    events: {
        'click .ddl_btn_ok': 'modal_close'
    },

    render: function() {
        this.$el.html(this.template(modalContact.toJSON()));
        return this;
    },

    modal_close: function(e) {
        hideDialog();
        var id = e.currentTarget.id;
        if (id == 'login_modal1_sinaPrompt' || (id == 'bindPhone_modal1_bindOk' && loginToBind) || id == 'bindByUsername_modal1_bindOk' || id == 'bindByPhone_modal1_bindOk') {
            ddlSDK.closePage();
        } else if ((id == 'bindPhone_modal1_bindOk' || id == 'bindQuestion_modal1_bindOk' || id == 'unbindPhone_toBind' || id == 'unbindQuestion_toBind') && !loginToBind) {
            appRouter.navigate('show/userCenter', { trigger: true });
        } else if(id == 'bindQuestion_modal1_bindOk'){
			ddlSDK.closePage();
		}
    },

});

//两个按钮的模态框模板
var modalTamplate2View = Backbone.View.extend({
    className: 'modal-content modalTamplate2_css_content',
    template: _.template($('#ddl_modalTamplate2').html()),

    events: {
        'click .ddl_btn_ok': 'modal_confirm',
        'click .ddl_btn_cancel': 'modal_cancel'
    },

    render: function() {
        this.$el.html(this.template(modalContact.toJSON()));
        return this;
    },

    modal_confirm: function(e) {
        var id = '#' + e.currentTarget.id;
        var name = $(id)[0].name;

        if (id == '#unbindPhone_modal_ok') {
            if (name == '0') {
                var code = $('#unbindPhone_input_identifyCode').val();
                //解绑手机
                var um = new UnbindModal();
                um.set({ UId: userInfo.uid, Token: userInfo.token, Code: code, BindType: 1 }); //1为解绑手机2为解绑密保
                console.log(JSON.stringify(um));
                um.save(null, {
                    success: function(model, response) {
                        hideDialog();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            //一年内已解绑过
                            if (response.Code == 10003) {
                                appRouter.navigate('show/userCenter', { trigger: true });
                            }
                            return;
                        }
                        //需要提示
                        toastr.success(ddlText.unbind_suc[languageIndex]);
                        if (userInfo.bindType == BINDTYPE_ALL) {
                            userInfo.bindType = BINDTYPE_ANSWER;
                        } else if (userInfo.bindType == BINDTYPE_PHONE) {
                            userInfo.bindType = BINDTYPE_NULL;
                        }
                        ddlSDK.updateUserInfo();

                        if (userInfo.bindType == BINDTYPE_NULL) {
                            $('#ddl_modal_dialog').empty();
                            modalContact.set({
                                modalTamplate_title: ddlText.security_level_low[languageIndex],
                                modalTamplate_body: ddlText.nobind_prompt[languageIndex],
                                modalTamplate_okid: 'unbindPhone_toBind',
                                modalTamplate_ok: ddlText.finish[languageIndex]
                            });
                            var mt = new modalTamplate1View();

                            $('#ddl_modal_dialog').html(mt.render().el);
                            showDialog();
                        } else {
                            appRouter.navigate('show/userCenter', { trigger: true });
                        }
                    },
                    error: function(err) {
                        hideDialog();
                        requestFailed();
                    }
                });
            } else {
                hideDialog();
                appRouter.navigate('show/userCenter', { trigger: true });
            }
        } else if (id == '#unbindQuestion_modal_ok') {
            if (name == '0') {
                var code = $('#unbindQuestion_input_identifyCode').val();
                //解绑密保
                var m = new UnbindQuestionModal();
                m.set({
                    Token: userInfo.token,
                    UId: userInfo.uid,
                    QuestionAnswer: [{
                        QuestionId: questionId0,
                        Answer: $.md5($('#unbindQuestion_div_clearAnswer01').val())
                    }, {
                        QuestionId: questionId1,
                        Answer: $.md5($('#unbindQuestion_div_clearAnswer11').val())
                    }]
                });
                m.save(null, {
                    success: function(model, response) {
                        hideDialog();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            return;
                        }
                        toastr.success(ddlText.unbind_suc[languageIndex]);
                        //需要提示
                        if (userInfo.bindType == BINDTYPE_ALL) {
                            userInfo.bindType = BINDTYPE_PHONE;
                        } else if (userInfo.bindType == BINDTYPE_ANSWER) {
                            userInfo.bindType = BINDTYPE_NULL;
                        }

                        ddlSDK.updateUserInfo();

                        if (userInfo.bindType == BINDTYPE_NULL) {
                            $('#ddl_modal_dialog').empty();
                            modalContact.set({
                                modalTamplate_title: ddlText.security_level_low[languageIndex],
                                modalTamplate_body: ddlText.nobind_prompt[languageIndex],
                                modalTamplate_okid: 'unbindQuestion_toBind',
                                modalTamplate_ok: ddlText.finish[languageIndex]
                            });
                            var mt = new modalTamplate1View();

                            $('#ddl_modal_dialog').html(mt.render().el);
                            showDialog();
                        } else {
                            appRouter.navigate('show/userCenter', { trigger: true });
                        }
                    },
                    error: function(err) {
                        hideDialog();
                        requestFailed();
                    }
                });
            } else {
                hideDialog();
                appRouter.navigate('show/userCenter', { trigger: true });
            }
        } else if (id == '#login_modal_ok') {
            if (name == '1') {
                appRouter.navigate('show/resetPasswordByPassword', { trigger: true });
            } else if (name == '2') {
                if (phoneRegister_switch == '1') {
                    appRouter.navigate('show/registerByUsername', { trigger: true });
                } else {
                    appRouter.navigate('show/registerByPhone', { trigger: true });
                }
            } else if (name == '0') {
                loginToBind = true;
                if (phoneRegister_switch == '1') {
                    bindIndex = 1;
                } else {
                    bindIndex = 0;
                }

                appRouter.navigate('show/validatePassword', { trigger: true });
            }
            hideDialog();
        } else if (id == '#userCenter_modal2_logout_ok') {
            if (userInfo.userType >= USERTYPE_SINA && userInfo.userType <= USERTYPE_VISITOR) {
                if (phoneRegister_switch == '1') {
                    appRouter.navigate('show/registerByUsername', { trigger: true });
                } else {
                    appRouter.navigate('show/registerByPhone', { trigger: true });
                }
            } else {
                ddlSDK.logout();
            }
        } else if (id == '#ddl_imgCode_ok') {
            if (validateImgCode('#ddl_input_imgCode')) {
                ddlSDK.showLoading();
                var vm = new ValidateImgCodeModal();
                vm.set({
                    Id: deviceId,
                    Code: $('#ddl_input_imgCode').val(),
                });
                console.log(JSON.stringify(vm));

                vm.save(null, {
                    success: function(model, response) {
                        ddlSDK.hideLoading();
                        console.log(response);
                        if (isReplyError(response.Message, response.Code)) {
                            getImgCode();
                            return;
                        }
                        imgCodeToken = response.Token;
                        //3手机注册，4手机重置密码，5绑定手机，6解绑手机
                        if (name == '3') {
                            ddlSDK.getDesString(phone, 'registerGetPhoneDesCallBack');
                        } else if (name == '4') {
                            resetPwdByPhoneSendCode();
                        } else if (name == '5') {
                            ddlSDK.getDesString(phone, 'bindPhoneGetPhoneDesCallback');
                        } else if (name == '6') {
                            unbindPhoneSendCode();
                        }
                        hideDialog();
                        $('#ddl_input_imgCode').val('');
                    },
                    error: function(err) {
                        getImgCode();
                        ddlSDK.hideLoading();
                        requestFailed();
                    }
                });
            }
        }
    },

    modal_cancel: function(e) {
        var id = '#' + e.currentTarget.id;
        hideDialog();
        if (id == '#ddl_imgCode_cancel') {
            $('#ddl_input_imgCode').val('');
        } else if (id != '#userCenter_modal2_logout_cancel' && id != '#unbindQuestion_modal_cancel' && id != '#unbindPhone_modal_cancel') {
            ddlSDK.closePage();
        }
    }

});

//存放每个界面的标题栏数据
var TitleContact = Backbone.Model.extend({
    defaults: {
        titleTamplateTitle: '',
        titleTamplateBackHtml: ''
    }
});

var titleContact = new TitleContact();

//标题栏模板
var TitleTamplateView = Backbone.View.extend({
    template: _.template($('#ddl_titleTamplate').html()),

    events: {
        'click .ddl_btn_back': 'ddl_goBack',
        'click .ddl_btn_close': 'ddl_close'
    },

    render: function() {
        this.$el.html(this.template(titleContact.toJSON()));
        return this;
    },

    ddl_goBack: function(e) {
        if (e.currentTarget.id == 'registerByPhone_btn_back' || e.currentTarget.id == 'registerByUsername_btn_back') {
            if (userInfo.userType == '') {
                appRouter.navigate('show/login', { trigger: true });
            } else {
                appRouter.navigate('show/userCenter', { trigger: true });
            }
        } else if(e.currentTarget.id == 'login_btn_back'){
              ddlSDK.showMainActivity()
         } else {
            history.back();
        }
    },

    ddl_close: function() {
        ddlSDK.closePage();
    }
});

//存放输入框数据
var InputContact = Backbone.Model.extend({
    defaults: {
        inputTamplateInputHtml: '',
        inputTamplateBtnId: '',
        inputTamplateSpanClass: '',
        inputTamplateInputPromptId: ''
    }
});

var inputContact = new InputContact();

//输入框模板
var lastPromptInput = null;
var InputTamplateView = Backbone.View.extend({
    template: _.template($('#ddl_inputTamplate').html()),
    promptId: '',
    events: {
        'click .ddl_btn_clearInput': 'ddl_clear',
        'focus .ddl_input_needClear': 'showClearBtn',
        'input .ddl_input_needClear': 'limit'
    },

    render: function() {
        this.$el.html(this.template(inputContact.toJSON()));
        return this;
    },

    ddl_clear: function(e) {
        var btnId = e.currentTarget.id;
        $('#' + btnId + '1').val('');
        $('#' + btnId).hide();
    },

    showClearBtn: function(e) {
        var inputId = '#' + e.currentTarget.id;
        this.promptId = inputId + '_prompt';
        if (lastPromptInput != null) {
            $(lastPromptInput).css('display', 'none');
        }
        $(this.promptId).css('display', 'table-cell');

        lastPromptInput = this.promptId;

        //若输入框内包含内容，第一次点击就出现叉
        if ($(inputId).val().length != 0) {
            $(inputId.substring(0, inputId.length - 1)).show();
        } else {
            inputLastNoSpaceValue = '';
            inputLastNoChineseValue = '';
        }
    },

    limit: function(e) {
        var inputId = '#' + e.currentTarget.id;
        //手机号输入框
        if (e.currentTarget.type == 'number') {
            limitInputLength($(inputId), 11);
            $(inputId).val($(inputId).val());
        } else if (e.currentTarget.type == 'password') {
            if ($(inputId).val() == '') {
                inputLastNoSpaceValue = '';
            }
            if (e.currentTarget.title == 'new') {
                deleteSpace($(inputId));
            }
        } else {
            if ($(inputId).val() == '') {
                inputLastNoChineseValue = '';
            }
            if (inputId.indexOf('clearAnswer') < 0 && inputId.indexOf('Realname') < 0) {
                deleteChinese($(inputId));
            }
        }

        //登录页面的密码输入框
        if (inputId == '#login_btn_clearPassword1') {
            password = $(inputId).val();
        } else if (inputId.indexOf('clearAnswer') > 0) { //密保的答案输入框
            limitInputLength($(inputId), 20);
        }

        //密码安全性提示
        if (inputId == '#registerByUsername_btn_clearPassword1' || inputId == '#resetPasswordByPhone_btn_clearPassword1' || inputId == '#resetPasswordByQuestionNext_btn_clearPassword1' ||
            inputId == '#resetPasswordByPassword_btn_clearPassword1') {
            var value = $(inputId).val();
            var input_length = value.length;

            if (input_length < 6) {
                $(this.promptId).text(ddlText.pwd_limit[languageIndex]);
            } else if (input_length < 9) {
                $(this.promptId).text(ddlText.pwd_level[languageIndex] + '：' + ddlText.low[languageIndex]);
            } else if (input_length < 11) {
                $(this.promptId).text(ddlText.pwd_level[languageIndex] + '：' + ddlText.mid[languageIndex]);
            } else if (input_length < 13) {
                $(this.promptId).text(ddlText.pwd_level[languageIndex] + '：' + ddlText.high[languageIndex]);
            } else {
                $(this.promptId).text(ddlText.pwd_limit[languageIndex]);
            }
        }

        //控制删除按钮的显示
        if ($(inputId).val().length == 0) {
            $(inputId.substring(0, inputId.length - 1)).hide();
        } else {
            $(inputId.substring(0, inputId.length - 1)).show();
        }
    }
});


function showDialog() {
    $('#ddl_gray_bg').show();
    $('#ddl_modal_dialog').css('display', 'table-cell');
    $('.dialog_father').css('display', 'table');
}

function hideDialog() {
    $('#ddl_gray_bg').hide();
    $('#ddl_modal_dialog').css('display', 'none');
    $('.dialog_father').css('display', 'none');
}